Object subclass: #BotInitializer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Network-IRC Bot'!


Object subclass: #IRCBaseFileReaderWriter
	instanceVariableNames: 'ql ib '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Network-IRC Bot'!
!IRCBaseFileReaderWriter commentStamp: 'wxm 8/24/2003 19:57' prior: 0!
an instance of this class houses the collections of rules and info for the bot - which is shared in a class variable of IRCBot.

This class separates out the interface between a file on disk and the live base running on the bot.

I have 2 IRCBotDictionary's per instance: 
	ib= info base, for things learned from the set command
	ql= quick links, for url resolutions (e.g. dict_http://www.dictionary.com)!
]style[(120 6 113 16 149)f2,f2LIRCBot Definition;,f2,f2LIRCBotDictionary Definition;,f2!


!IRCBaseFileReaderWriter methodsFor: 'accessors'!
ib
	^ ib! !

!IRCBaseFileReaderWriter methodsFor: 'accessors' stamp: 'wxm 9/25/2003 18:35'!
initialize
	self initBase; initQuick.
	self
		on:  self class DefaultBaseFile! !

!IRCBaseFileReaderWriter methodsFor: 'accessors'!
ql
	^ ql! !


!IRCBaseFileReaderWriter methodsFor: 'modifiers'!
ib: t1 
	ib _ t1! !

!IRCBaseFileReaderWriter methodsFor: 'modifiers'!
ql: t1 
	ql _ t1! !

!IRCBaseFileReaderWriter methodsFor: 'modifiers' stamp: 'wxm 9/2/2003 22:04'!
storeBase
	| |
	^self storeBaseOn: (self class DefaultBaseFile)! !


!IRCBaseFileReaderWriter methodsFor: 'as yet unclassified' stamp: 'wxm 8/22/2003 00:08'!
initBase
	ib
		ifNil: [ib _ IRCBotDictionary new]! !

!IRCBaseFileReaderWriter methodsFor: 'as yet unclassified' stamp: 'wxm 8/22/2003 00:08'!
initQuick
	ql
		ifNil: [ql _ IRCBotDictionary new]! !

!IRCBaseFileReaderWriter methodsFor: 'as yet unclassified' stamp: 'wxm 9/25/2003 19:22'!
on: file 
	| ln key kkey val vval |
	file closed ifFalse: [
	[((ln _ file nextLine) findString: '@infobase@')
		> 0]
		whileFalse: [ln
				ifNil: [^ nil]].
	[(ln findString: '@quicklinks@')
			= 0
		and: [ln notNil]]
		whileTrue: [ln _ ln findTokens: ' '.
			key _ ln copyUpTo: '=>'.
			kkey _ ''.
			key
				do: [:k | kkey _ kkey , k , ' '].
			kkey _ kkey withoutTrailingBlanks.
			kkey size > 1
				ifTrue: ["kkey _ kkey copyWithoutFirst."
					val _ ln copyAfter: '=>'.
					vval _ ''.
					val
						do: [:v | vval _ vval , v , ' '].
					vval _ vval withoutTrailingBlanks.
					ib at: kkey put: vval].
			ln _ file nextLine].
	[ln notNil]
		whileTrue: [ln _ ln findTokens: ' '.
			key _ ln copyUpTo: '=>'.
			kkey _ ''.
			key
				do: [:k | kkey _ kkey , k , ' '].
			kkey _ kkey withoutTrailingBlanks.
			kkey size > 1
				ifTrue: ["kkey _ kkey copyWithoutFirst."
					val _ ln copyAfter: '=>'.
					vval _ ''.
					val
						do: [:v | vval _ vval , v , ' '].
					vval _ vval withoutTrailingBlanks.
					ql at: kkey put: vval].
			ln _ file nextLine].
	file flush; close].! !

!IRCBaseFileReaderWriter methodsFor: 'as yet unclassified' stamp: 'wxm 9/25/2003 19:22'!
storeBaseOn: f 
	| mstr |
	f closed ifFalse: [
	f nextPutAll: '!!@infobase@!!' , String cr.
	ib
		keysAndValuesDo: [:k :v | 
			mstr _ k , ' => ' , v.
			f nextPutAll: mstr.
			f nextPut: Character cr].
	f nextPutAll: '!!@quicklinks@!!' , String cr.
	ql
		keysAndValuesDo: [:k :v | 
			mstr _ k , ' => ' , v.
			f nextPutAll: mstr.
			f nextPut: Character cr].
	f flush; close.
	^ f localName].
	^#error! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

IRCBaseFileReaderWriter class
	instanceVariableNames: ''!

!IRCBaseFileReaderWriter class methodsFor: 'as yet unclassified' stamp: 'wxm 9/25/2003 18:35'!
DefaultBaseFile
	^ FileDirectory default fileNamed: 'ircbot-base.txt'! !

!IRCBaseFileReaderWriter class methodsFor: 'as yet unclassified' stamp: 'wxm 8/24/2003 19:59'!
new
	|e|
	e _  super new.
	^e initialize! !


IRCConnectionEnhanced subclass: #IRCBot
	instanceVariableNames: 'preResponses preGreets genesis ct incomingMsgChunk compiler startupJoins '
	classVariableNames: 'FileClerk '
	poolDictionaries: ''
	category: 'Network-IRC Bot'!
!IRCBot commentStamp: 'wxm 8/3/2003 20:42' prior: 0!
http://minnow.cc.gatech.edu/squeak/3293

As of the first version you cannot just run it programmatically... I have not been successful at separating the IRCConnection "entity" from the Morphic console/controller. So - you have to have the morph console open or no messages make it to the bot.

Anyway - this is probably more info than you care about. 

Put the following in a workspace. 
bot _ IRCBot new. 
bot nick: 'clever-name'. 
bot openAsMorph. 
bot connect.

now it should be up and running.  send your bot the join commands from another client!!
!
]style[(39 513)f4Rhttp://minnow.cc.gatech.edu/squeak/3293;,f4!


!IRCBot methodsFor: 'accessors' stamp: 'wxm 9/2/2003 22:26'!
activateNow
	self openAsMorph.
	[(Delay forSeconds: 1) wait.
	self connect] fork.
	[(Delay forSeconds: 60) wait.
	self startupJoins
		do: [:channel | "append the damn $# if its left out"
			self join: (((channel includes: $#)
					ifTrue: ['']
					ifFalse: ['#'])
					, channel)]] fork! !

!IRCBot methodsFor: 'accessors' stamp: 'wxm 9/7/2003 13:06'!
botProcess: mesg 
	| content contentCol lastSpaceAfterNick |
	content _ mesg arguments last.
	incomingMsgChunk _ IncomingMsg new: mesg.
	"test for private message"
	incomingMsgChunk
		channel: (incomingMsgChunk channel = self nick
				ifTrue: [incomingMsgChunk sender]
				ifFalse: [incomingMsgChunk channel]).
	(contentCol _ incomingMsgChunk sentence) isEmptyOrNil
		ifTrue: [^ true].
	"this is so nasty - let me explain. first it checks if the nick name 
	is at the beginning, then it checks if its at the end. before it  
	can go thru with the processing though it also checks if the  
	nickname is actually the token and not part of some other  
	word. ex: oi/oink...."
	(contentCol first asLowercase copyWithoutAll: ':,')
			= self nick asLowercase
		ifFalse: [(contentCol last asLowercase copyWithoutAll: ':,?.!!')
					= self nick asLowercase
				ifTrue: [contentCol addFirst: contentCol removeLast.
					contentCol
						addLast: (contentCol removeLast copyWithout: ',:;.?!!')]
				ifFalse: [^ true]].
	(contentCol size > 1
			and: [lastSpaceAfterNick _ self nick size
							+ (content findString: self nick).
				content size < lastSpaceAfterNick
					or: [(content at: lastSpaceAfterNick) isLetter not]])
		ifTrue: [^ self performService].
	"^ self respondRetarded: pass"
	true! !

!IRCBot methodsFor: 'accessors' stamp: 'wxm 9/2/2003 22:22'!
channel
	"this is the command line parameter 'channel' - not to be 
	confused with what you would initially believe it performs...  
	I assumed no one wanted to type 'channeltojoinatstartup' - so 
	this IRC thing can be nerdy and vague and have things that are 
	not very descriptive in them"
	^startupJoins! !

!IRCBot methodsFor: 'accessors' stamp: 'wxm 9/2/2003 22:31'!
channel: arg 
	
	^ startupJoins add: arg! !

!IRCBot methodsFor: 'accessors'!
compiler
	^ compiler! !

!IRCBot methodsFor: 'accessors'!
ct
	^ ct! !

!IRCBot methodsFor: 'accessors'!
fileClerk
	^ fileClerk! !

!IRCBot methodsFor: 'accessors'!
genesis
	^ genesis! !

!IRCBot methodsFor: 'accessors'!
incomingMsgChunk
	^ incomingMsgChunk! !

!IRCBot methodsFor: 'accessors'!
preGreets
	^ preGreets! !

!IRCBot methodsFor: 'accessors'!
preResponses
	^ preResponses! !

!IRCBot methodsFor: 'accessors'!
startupJoins
	^ startupJoins! !


!IRCBot methodsFor: 'modifiers'!
compiler: t1 
	compiler _ t1! !

!IRCBot methodsFor: 'modifiers'!
ct: t1 
	ct _ t1! !

!IRCBot methodsFor: 'modifiers'!
fileClerk: t1 
	fileClerk _ t1! !

!IRCBot methodsFor: 'modifiers'!
genesis: t1 
	genesis _ t1! !

!IRCBot methodsFor: 'modifiers'!
incomingMsgChunk: t1 
	incomingMsgChunk _ t1! !

!IRCBot methodsFor: 'modifiers'!
preGreets: t1 
	preGreets _ t1! !

!IRCBot methodsFor: 'modifiers'!
preResponses: t1 
	preResponses _ t1! !

!IRCBot methodsFor: 'modifiers'!
startupJoins: t1 
	startupJoins _ t1! !


!IRCBot methodsFor: 'msg process incoming' stamp: 'wxm 9/7/2003 13:03'!
processMessage: aspD 
	IRCBot Debug
		ifTrue: [Transcript show: aspD printString;
				 cr].
	super processMessage: aspD.
	(aspD command match: 'PRIVMSG')
		ifTrue: [self botProcess: aspD.
			]! !


!IRCBot methodsFor: 'database functions' stamp: 'wxm 9/1/2003 20:47'!
base
	^ FileClerk ib! !

!IRCBot methodsFor: 'database functions' stamp: 'wxm 9/25/2003 20:10'!
performService
	"This method is HORENDOUS.  
	I have since learned SmaCC very intimately...  
	however, I cannot justify 'throwing it all away' and starting  
	over with  
	another paradigm of coding (the correct and more elegant one  
	albeit),  
	when this code	*works fine now*"
	| channel tokens fetch newEntry dkey dasString locKey isIndex noflag command |
	channel _ incomingMsgChunk channel.
	tokens _ incomingMsgChunk sentence.
	command _ incomingMsgChunk command.
	ct _ ct + 1.
	"=============================  
	bot, JOIN squeak  
	============================="
	(command asLowercase findString: 'join')
			> 0
		ifTrue: [dkey _ tokens at: 3.
			(dkey at: 1)
					= $#
				ifFalse: [dkey _ '#' , dkey].
			^ self
				sendMessage: (IRCProtocolMessage
						command: 'JOIN'
						arguments: (Array with: dkey))].
	"=============================  
	bot, Greet <somebody>  
	============================="
	(command asLowercase findString: 'greet')
			> 0
		ifTrue: [locKey _ tokens copyFrom: 3 to: tokens size.
			dkey _ ''.
			locKey
				do: [:str | dkey _ dkey , str , ' '].
			dkey _ dkey withoutTrailingBlanks copyWithoutAll: ',;'.
			dasString _ self randGreet.
			^ self
				botResponse: (Array with: channel with: dkey , ': ' , dasString)].
	"=============================  
	bot, url: [url] shorthand [url-key]  
	============================="
	(tokens size = 5
			and: [((command asLowercase copyUpTo: $:)
						match: 'url')
					and: [(tokens at: 4)
							= 'shorthand']])
		ifTrue: [dasString _ (tokens at: 3)
						copyWithout: ''''.
			dkey _ (tokens at: 5)
						copyWithout: ''''.
			self quick at: dkey asLowercase put: dasString.
			^ self
				botResponse: (Array with: channel with: 'Got it!!')].
	"=============================  
	bot, part squeak  
	============================="
	(command asLowercase match: 'part')
		ifTrue: [tokens size < 3
				ifFalse: [dkey _ tokens at: 3.
					(dkey at: 1)
							= $#
						ifFalse: [dkey _ '#' , dkey].
					^ self
						sendMessage: (IRCProtocolMessage
								command: 'PART'
								arguments: (Array with: dkey))]].
	"=============================  
	bot, status?  
	============================="
	(command asLowercase findString: 'status')
			> 0
		ifTrue: [fetch _ Time dateAndTimeNow.
			dasString _ 'I was invoked on ' , genesis first printString , ' ' , genesis second printString , '.  '.
			fetch second < genesis second
				ifTrue: [dasString _ dasString , ((fetch first subtractDate: genesis first)
									- 1) asString , ' days have elapsed.']
				ifFalse: [dasString _ dasString , (fetch first subtractDate: genesis first) asString , ' days have elapsed.'].
			dasString _ dasString , '  I have been queried a total of ' , ct asString , ' times.'.
			^ self
				botResponse: (Array with: channel with: dasString)].
	"=============================  
	bot, evaluate: ( Time now ).  
	============================="
	(command asLowercase findString: 'eval')
			= 1
		ifTrue: [dkey _ ''.
			locKey _ tokens copyWithoutFirst.
			locKey copyWithoutFirst
				do: [:str | dkey _ dkey , str , ' '].
			dkey _ dkey withoutTrailingBlanks.
			locKey _ (command asLowercase findString: 'time')
							> 0
						ifTrue: [self compiler timeEvaluate: dkey]
						ifFalse: [self compiler evaluate: dkey].
			^ self
				botResponse: (Array with: channel with: locKey)].
	"=============================  
	bot, forget Dykstra  
	============================="
	(command asLowercase match: 'forget')
		ifTrue: [locKey _ tokens copyWithoutFirst.
			locKey _ locKey copyWithoutFirst.
			dkey _ ''.
			locKey
				do: [:str | dkey _ dkey , str , ' '].
			(self base
				removeKey: (dkey copyWithoutAll: ',.;!!?:'))
				ifNotNil: [^ self
						botResponse: (Array with: channel with: 'I have forgotten everything I knew about ' , dkey)]].
	"=============================  
	bot, actorsbio, David Bowie  
	============================="
	(command asLowercase findString: 'actorsbio')
			> 0
		ifTrue: [^ self appealToIMDB].
	"=============================  
	bot, eToys is [also]* part of squeak  
	bot, no, squeak is a programming language  
	 
	============================="
	(tokens intersection: #('is' )) isEmptyOrNil
		ifFalse: [locKey _ tokens copyWithoutFirst.
			locKey _ locKey copyUpTo: 'is'.
			isIndex _ tokens indexOf: 'is'.
			(tokens size < (isIndex + 1)
					or: [locKey isEmpty])
				ifFalse: [(tokens at: isIndex + 1) asLowercase = 'also'
						ifTrue: [dkey _ ''.
							"get rid of 'no' if it is present in an 'is  
							also'  
							command."
							(locKey first copyUpTo: $,)
									= 'no'
								ifTrue: [locKey _ locKey copyWithoutFirst].
							locKey
								do: [:str | dkey _ dkey , str , ' '].
							newEntry _ self base at: dkey.
							newEntry isEmptyOrNil
								ifFalse: [newEntry _ newEntry , '.  Also, '].
							(tokens copyFrom: isIndex + 2 to: tokens size)
								do: [:tok | newEntry _ newEntry , tok , ' '].
							self base at: dkey put: newEntry.
							^ self
								botResponse: (Array with: channel with: 'Got it!!')]
						ifFalse: [dkey _ ''.
							noflag _ nil.
							(locKey first copyUpTo: $,)
									= 'no'
								ifTrue: [noflag _ true.
									locKey _ locKey copyWithoutFirst].
							locKey
								do: [:str | dkey _ dkey , str , ' '].
							newEntry _ ''.
							(tokens copyFrom: isIndex + 1 to: tokens size)
								do: [:tok | newEntry _ newEntry , tok , ' '].
							dkey withBlanksTrimmed asLowercase ~= 'what'
								ifTrue: [(fetch _ self base at: dkey)
										ifNil: [self base at: dkey put: newEntry.
											^ self
												botResponse: (Array with: channel with: 'Got it!!')]
										ifNotNil: [noflag
												ifNil: [dasString _ incomingMsgChunk sender , ': ' , 'But ' , dkey withoutTrailingBlanks , ' is ' , fetch.
													^ self
														botResponse: (Array with: channel with: dasString)]
												ifNotNil: [self base at: dkey put: newEntry.
													^ self
														botResponse: (Array with: channel with: 'Got it!!')]]]]]].
	"=============================  
	bot, [url-key] [to-append]  
	============================="
	(self quickLink: tokens channel: channel)
		ifNotNil: [^ true].
	"=============================  
	bot, Morphic?  
	bot, what is Morphic?  
	============================="
	dkey _ ''.
	(command asLowercase = 'what'
		ifTrue: [tokens copyAfter: 'is']
		ifFalse: [tokens copyWithoutFirst])
		do: [:str | dkey _ dkey , str , ' '].
	dkey _ dkey copyWithoutAll: '?,;'.
	dkey _ dkey withoutTrailingBlanks.
	(fetch _ self base at: dkey) notNil
		ifTrue: [(fetch findString: '<reply>')
					> 0
				ifTrue: [^ self
						botResponse: (Array with: channel with: (fetch copyAfter: $>) withBlanksTrimmed)].
			(fetch findString: '<eval>')
					> 0
				ifTrue: [^ self
						botResponse: (Array
								with: channel
								with: (self
										evaluate: (fetch copyAfter: $>)))].
			^ self
				botResponse: (Array with: channel with: dkey , ' is ' , fetch)].
	"=============================  
	bot, squeakmap, David Bowie  
	============================="
	(command asLowercase match: 'squeakmap')
		ifTrue: [^ self appealToSM].
	"=============================  
	bot, uffda moo moo moo  
	============================="
	(tokens intersection: #('moo' 'uffda' )) isEmptyOrNil
		ifFalse: [dasString _ incomingMsgChunk sender first , ': '.
			tokens copyWithoutFirst
				do: [:str | dasString _ dasString , str , ' '].
			^ self
				botResponse: (Array with: channel with: dasString)].
	"=============================  
	bot, go squeak go  
	============================="
	dkey _ ''.
	tokens copyWithoutFirst
		do: [:str | dkey _ dkey , str , ' '].
	(dkey findString: 'go squeak go')
			> 0
		ifTrue: [^ self replyRandomly: channel].
	"=============================  
	bot, scakljk har moobley  
	============================="
	self
		botResponse: (Array with: channel with: 'Huh? try again')! !

!IRCBot methodsFor: 'database functions' stamp: 'wxm 9/1/2003 20:46'!
quick
	^ FileClerk ql! !


!IRCBot methodsFor: 'compiler tricks' stamp: 'wxm 8/19/2003 00:50'!
evaluate: aString 
^self compiler evaluate: aString! !

!IRCBot methodsFor: 'compiler tricks' stamp: 'wxm 7/19/2003 13:32'!
notify: aString at: location in: sourceStream
^#boognish! !

!IRCBot methodsFor: 'compiler tricks' stamp: 'wxm 7/19/2003 13:31'!
select
^#boognish! !

!IRCBot methodsFor: 'compiler tricks' stamp: 'wxm 7/19/2003 14:21'!
selectFrom: aPos to: anotherPos
^	#boognish
! !

!IRCBot methodsFor: 'compiler tricks' stamp: 'wxm 7/19/2003 14:20'!
selectionInterval
	^ 1 to: 1! !

!IRCBot methodsFor: 'compiler tricks' stamp: 'wxm 7/19/2003 14:22'!
text
	^ Text fromString: ''! !


!IRCBot methodsFor: 'as yet unclassified' stamp: 'wxm 8/19/2003 01:45'!
bindings ^ compiler bindings! !

!IRCBot methodsFor: 'as yet unclassified' stamp: 'wxm 7/3/2003 11:14'!
connect
	"connect to a server"
	| addr |
	Socket initializeNetwork.
	socket
		ifNotNil: [socket destroy].
	self reset.
	Utilities
		informUser: 'looking up server address...'
		during: [addr _ NetNameResolver addressForName: server].
	addr
		ifNil: [^ self inform: 'could not find address for ' , server].
	socket _ Socket new.
	socket connectTo: addr port: port.
	self
		sendMessage: (IRCProtocolMessage fromString: 'NICK ' , nick).
	self
		sendMessage: (IRCProtocolMessage fromString: 'USER ' , userName , ' * * :' , fullName)! !

!IRCBot methodsFor: 'as yet unclassified' stamp: 'wxm 9/7/2003 13:11'!
defaultStartSettings
	"these are what get executed if you pass no command line 
	arguments... will they ever become obsolete?"
	self server: 'calvino.freenode.net'.
	self nick: 'oi'.
	self userName: 'oi'.
	self fullName: 'Jedi Knight Oi'.
	self startupJoins add: '#squeak'; add: '#oitest'! !

!IRCBot methodsFor: 'as yet unclassified' stamp: 'wxm 9/2/2003 23:05'!
initialize
	super initialize.
	startupJoins _ Set new.
	compiler _ IRCBotCompiler new.

	compiler bot: self.
	compiler initialize.
	self initRandomly.
	genesis _ Time dateAndTimeNow.
	ct _ 0.
	self defaultStartSettings! !

!IRCBot methodsFor: 'as yet unclassified' stamp: 'wxm 7/19/2003 11:48'!
randGreet
	^preGreets atRandom! !

!IRCBot methodsFor: 'as yet unclassified' stamp: 'wxm 7/4/2003 12:42'!
replyRandomly
	^preResponses atRandom! !

!IRCBot methodsFor: 'as yet unclassified' stamp: 'wxm 9/1/2003 21:18'!
startUpDefault
	self server: 'calvino.freenode.net'.
	self nick: 'oi'.
	self userName: 'oi'.
	self fullName: 'Jedi Knight Oi'.
	^self.! !


!IRCBot methodsFor: 'msg process outgoing new' stamp: 'wxm 7/29/2003 21:19'!
appealToIMDB
	
	| strURL h dirt rr pa dog boon isp toRtn channel name |

	name _ 	incomingMsgChunk argumentsToCommand.
channel _ incomingMsgChunk channel.
	strURL _ 'http://www.imdb.com/Bio?'.
	dirt _ name last.
	dirt at: 1 put: (dirt at: 1) asUppercase.
	strURL _ strURL , dirt , ','.
	(name allButLast)
		do: [:ein | 
			dirt _ ein.
			dirt at: 1 put: (dirt at: 1) asUppercase.
			strURL _ strURL , '%20' , dirt].
	[h _ HTTPSocket httpGet: strURL.
	rr _ ReadStream on: h contents.
	pa _ HtmlParser parse: rr contents.
	dog _ pa body contents.
	boon _ (dog contents
				collect: [:eh | eh class = HtmlDefinitionDefinition
						ifTrue: [eh]])
				copyWithout: nil.
	isp _ boon
				collect: [:mo | [mo contents first attributes at: 'class'.
					mo]
						ifError: [:a :b | nil]].
	isp _ isp copyWithout: nil.
	(toRtn _ isp first contents first contents first text)
		ifNil: [toRtn _ 'Sorry, I can''t find anything'].
	toRtn _ OrderedCollection with: channel with: toRtn.
	self botResponse: toRtn]
		ifError: [:a :b | 
			toRtn _ 'On IMDB-bios, I can''t find anything for '.
			(name)
				do: [:str | toRtn _ toRtn , str , ' '].
			toRtn _ OrderedCollection with: channel with: toRtn.
			self botResponse: toRtn]! !

!IRCBot methodsFor: 'msg process outgoing new' stamp: 'wxm 8/17/2003 15:03'!
appealToSM
	"channel _ chunk key."
	| toRtn channel strURL sstr h rr dog target package |
	channel _ incomingMsgChunk channel.
	package _ incomingMsgChunk argumentsToCommand.
	strURL _ 'http://map1.squeakfoundation.org/sm/packagesbyname'.
	sstr _ ''.
	package
		do: [:str | sstr _ sstr , str , ' '].
	sstr _ sstr withoutTrailingBlanks.
	sstr _ '>' , sstr.
	[h _ HTTPSocket httpGet: strURL.
	rr _ ReadStream on: h contents.
	dog _ rr contents.
	sstr _ sstr asLowercase.
	target _ (dog _ dog asLowercase printString) findString: sstr.
	strURL _ 'http://map1.squeakfoundation.org'.
	strURL _ strURL
				, (dog copyFrom: target - 49 to: target - 2).
	self
		botResponse: (Array with: channel with: strURL)]
		ifError: [:a :b | 
			toRtn _ 'On Squeakmap, I can''t find anything for '.
			package
				do: [:str | toRtn _ toRtn , str , ' '].
			toRtn _ toRtn , '.  I suggest checking the case sensitivity of the desired package!!'.
			toRtn _ Array with: channel with: toRtn.
			self botResponse: toRtn]! !

!IRCBot methodsFor: 'msg process outgoing new' stamp: 'wxm 8/14/2003 08:39'!
botResponse: mesg 
	| art |
	IRCBot Debug
		ifTrue: [Transcript show: 'I am sending this:  
	_____________________  
	' , mesg printString;
				 cr].
	art _ self fillEscapeSequences: mesg second.
	art size > 750
		ifTrue: [art _ art copyFrom: 1 to: 750.
			art _ art , '...........'].
	[(art findTokens: String cr)
		do: [:eh | self sendMessage: (IRCProtocolMessage
				command: 'PRIVMSG'
				arguments: (Array with: mesg first with: eh))]]
		ifError: [:a :b | 
			Transcript show: 'problem sending: ' , mesg printString , '
_________________ as private message';
				 cr.
			^ false].
	^ true! !

!IRCBot methodsFor: 'msg process outgoing new' stamp: 'wxm 8/21/2003 23:18'!
fillEscapeSequences: hart 
	| art |
	art _ hart copy.
	art _ art copyReplaceTokens: '%s' with: self nick.
	art _ art copyReplaceTokens: '%u' with: incomingMsgChunk sender.
	art _ art copyReplaceTokens: '%t' with: Time now printString.
	art _ art copyReplaceTokens: '%v' with: Smalltalk systemInformationString.
	art _ art copyReplaceTokens: '%c' with: incomingMsgChunk channel.
	^ art! !

!IRCBot methodsFor: 'msg process outgoing new' stamp: 'wxm 7/21/2003 18:56'!
initRandomly
	"more things can be added - but who cares"
	preGreets _ {'yo - how''s it goin?'. 'what''s new partner?'. 'how''s it shakin''?'. 'whazzzzzzzup?'. 'uffda!!'. 'what''s it like out there today?'. 'do you have any mustard?'. 'right bag of wank it is, seeing you here again!!'. 'hey hey hey'. 'welcome to the #squeak'. 'mahalo dude!!'}.
	"the prerespsonses are just random stuff said to no one in  
	particular, whereas the pregreets are directed at a given person"
	preResponses _ OrderedCollection new.
	preResponses add: self nick , ' evaluate: ' , '(Random theItsCompletelyBrokenTest)'.
	preResponses add: 'http://antwrp.gsfc.nasa.gov/apod/astropix.html'.
	preResponses add: 'http://mathworld.wolfram.com/topics/Puzzles.html'.
	preResponses add: 'http://www.osei.noaa.gov/OSEIiod.html'.
	preResponses add: 'http://story.news.yahoo.com/news?tmpl=index2&cid=1756'.
	preResponses add: HTTPSocket userAgentString.
	preResponses add: 'http://www.squeakland.org/'.
	preResponses add: self nick , ' evaluate: ' , '(Color wheel: 32)'! !

!IRCBot methodsFor: 'msg process outgoing new' stamp: 'wxm 9/20/2003 18:07'!
quickLink: tokens channel: channel 
	| locKey targetCol targetStr |
	locKey _ self quick
				at: ((tokens at: 2) copyUpTo: $:)
				ifAbsent: [^ nil].
	targetCol _ tokens copyFrom: 3 to: tokens size.
	targetStr _ ''.
	targetCol
		do: [:str | targetStr _ targetStr , str , '%20'].
	targetStr _ targetStr copyUpToLast: $%.
	^ self
		botResponse: (Array with: channel with: locKey , targetStr)! !

!IRCBot methodsFor: 'msg process outgoing new' stamp: 'wxm 8/14/2003 22:06'!
replyRandomly: channel
	^ self
				botResponse: (Array with: channel with: preResponses atRandom)! !

!IRCBot methodsFor: 'msg process outgoing new' stamp: 'wxm 8/3/2003 20:44'!
respondRetarded: chunk 
"this replies to everything with trash"
	| sender channel toSend contentCol str |
	(sender _ chunk first) isEmptyOrNil
		ifTrue: [sender _ ''].
	channel _ chunk second.
	contentCol _ chunk last.
	str _ ''.
	contentCol
		do: [:uh | str _ str , uh , ' '].
	toSend _ OrderedCollection with: channel with: str , '. ' , sender , ' have a nice day!! '.
	self botResponse: toSend! !

!IRCBot methodsFor: 'msg process outgoing new' stamp: 'wxm 8/21/2003 23:01'!
say: aString 
	self
		botResponse: (Array with:(incomingMsgChunk channel) with: aString).
	^ ''! !

!IRCBot methodsFor: 'msg process outgoing new' stamp: 'wxm 8/21/2003 17:12'!
say: aString toChannel: ch 
	self
		botResponse: (Array with: ch with: aString).
	^''.! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

IRCBot class
	instanceVariableNames: ''!

!IRCBot class methodsFor: 'start and stop' stamp: 'wxm 9/20/2003 14:16'!
security
	| ffiHere |
	ffiHere _ true.
	[(ByteArray new: 4)
		signedLongAt: 1]
		on: Error
		do: [:ex | ffiHere _ false].
	ffiHere
		ifTrue: [self error: 'FFI is accessible'].
	SecurityManager default enterRestrictedMode.! !

!IRCBot class methodsFor: 'start and stop' stamp: 'wxm 9/1/2003 23:54'!
shutDown
	[

		self fileClerk storeBase]
		ifError: [:a :b | Transcript show: 'There was a problem writing out the bot''s info file!!']! !

!IRCBot class methodsFor: 'start and stop' stamp: 'wxm 9/20/2003 14:16'!
startUp
	| bourne et i key val |

	bourne _ self new.
	bourne isConnected
		ifFalse: ["pulls the associations out of the command line arguments 
			- if  
			present - then starts up the bot hopefullly"
			i _ 3.
			[(et _ Smalltalk getSystemAttribute: i) isEmptyOrNil]
				whileFalse: [i _ i + 1.
					(({'nick'. 'server'. 'port'. 'username'. 'fullname'. 'channel'}
								includes: [key _ (et copyUpTo: $-) asLowercase])
							and: [val _ et copyAfter: $>])
						ifTrue: [bourne perform: (key , ':') asSymbol with: val]].
			bourne activateNow].
	^ bourne! !

!IRCBot class methodsFor: 'start and stop' stamp: 'wxm 9/1/2003 22:22'!
startUp: reg
	| |
	^self startUp! !


!IRCBot class methodsFor: 'as yet unclassified' stamp: 'wxm 8/21/2003 23:47'!
Base
	^FileClerk ib! !

!IRCBot class methodsFor: 'as yet unclassified' stamp: 'wxm 9/7/2003 13:08'!
Debug
	^ false! !

!IRCBot class methodsFor: 'as yet unclassified' stamp: 'wxm 8/21/2003 23:47'!
QuickLinks
	^ FileClerk ql! !

!IRCBot class methodsFor: 'as yet unclassified' stamp: 'wxm 8/21/2003 23:51'!
fileClerk
	^FileClerk! !

!IRCBot class methodsFor: 'as yet unclassified' stamp: 'wxm 9/22/2003 23:44'!
initialize
	self postscript.
	! !

!IRCBot class methodsFor: 'as yet unclassified' stamp: 'wxm 9/24/2003 19:12'!
new
	"changed so that the fileClerk is initialized from file on EVERY startup... 
	since we no longer have a persistent image... we must depend on the 
	filesystem for persistence... "
	"ANOTHER REASON TO IMPLEMENT Minnestore or Magma?!!"
	FileClerk _ IRCBaseFileReaderWriter new.
	self allInstances notEmpty
		ifFalse: [^ super new initialize].
	^ self allInstances first! !

!IRCBot class methodsFor: 'as yet unclassified' stamp: 'wxm 9/20/2003 14:41'!
postscript

Preferences disable: #readDocumentAtStartup.

Preferences 
		setPreference: #securityChecksEnabled 
		toValue: true.
Preferences 
		setPreference: #warnAboutInsecureContent 
		toValue: false.
	

Smalltalk addToShutDownList: IRCBot.
Smalltalk addToStartUpList: IRCBot.
! !


Object subclass: #IRCBotCompiler
	instanceVariableNames: 'bindings bot '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Network-IRC Bot'!
!IRCBotCompiler commentStamp: 'wxm 8/19/2003 00:20' prior: 0!
I don't really compile anything.
I am just responsible for interfacing to the Compiler.
I also, however, keep a bindings for the bot.  This always for things like:

<me> oi: evaluate: (myVar := 'tops off')


!
]style[(78 8 122)f4,f4LCompiler Definition;,f4!


!IRCBotCompiler methodsFor: 'accessors'!
bindings
	^ bindings! !

!IRCBotCompiler methodsFor: 'accessors'!
bot
	^ bot! !


!IRCBotCompiler methodsFor: 'modifiers'!
bindings: t1 
	bindings _ t1! !

!IRCBotCompiler methodsFor: 'modifiers'!
bot: t1 
	bot _ t1! !


!IRCBotCompiler methodsFor: 'binding' stamp: 'wxm 8/19/2003 01:29'!
bindingOf: aString 
	IRCBot Debug ifTrue: [Transcript show: 'by god it works';
		 cr].
	bindings isNil
		ifTrue: [bindings _ Dictionary new].
	(bindings includesKey: aString)
		ifFalse: [bindings at: aString put: nil].
	^ bindings associationAt: aString! !

!IRCBotCompiler methodsFor: 'binding' stamp: 'wxm 8/22/2003 18:26'!
evaluate: aString 
	| loc i |
	loc _ #incorrigible.
	[loc _ [Compiler
				evaluate: ((self bot)
						fillEscapeSequences: aString)
				for: self
				notifying: self
				logged: false]
				ifError: [:a :b | #error]] fork.
	i _ 1.
	[loc = #incorrigible
		and: [i < 15]]
		whileTrue: [(Delay forMilliseconds: 1000) wait.
			i _ i + 1].
	^ loc printString! !

!IRCBotCompiler methodsFor: 'binding' stamp: 'wxm 8/22/2003 00:49'!
initialize
	bindings _ Dictionary new.

	bindings at: 'bot' put: bot!
]style[(10 2 8 3 10 8 8 5 5 6 3)f2b,f2,f2cmagenta;,f2,f2cmagenta;,f2,f2cmagenta;,f2,f2c150048000,f2,f2cmagenta;! !

!IRCBotCompiler methodsFor: 'binding' stamp: 'wxm 9/25/2003 18:30'!
timeEvaluate: aString 
	| rtn t |
	t _ Time
				millisecondsToRun: [rtn _ self evaluate: aString].
	^ rtn , String cr , 'it took me ' , t asString , 'ms...'!
]style[(14 7 4 6 4 1 3 4 25 3 3 4 11 7 6 3 3 6 6 13 3 10 3 7)f1b,f1cblue;b,f1,f1cblue;i,f1,f1cblue;i,f1,f1cmagenta;,f1,f1cblue;i,f1,f1cmagenta;,f1,f1cblue;i,f1,f1cblue;i,f1,f1cmagenta;,f1,f1c150048000,f1,f1cblue;i,f1,f1c150048000! !


!IRCBotCompiler methodsFor: 'as yet unclassified' stamp: 'wxm 8/19/2003 00:08'!
notify: aString at: location in: sourceStream 
	^ #boognish! !

!IRCBotCompiler methodsFor: 'as yet unclassified' stamp: 'wxm 8/19/2003 00:09'!
select
	^ #boognish! !

!IRCBotCompiler methodsFor: 'as yet unclassified' stamp: 'wxm 8/19/2003 00:09'!
selectFrom: aPos to: anotherPos 
	^ #boognish! !

!IRCBotCompiler methodsFor: 'as yet unclassified' stamp: 'wxm 8/19/2003 00:10'!
selectionInterval
	^ 1 to: 1! !

!IRCBotCompiler methodsFor: 'as yet unclassified' stamp: 'wxm 8/19/2003 00:10'!
text
	^ Text fromString: ''! !


Dictionary subclass: #IRCBotDictionary
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Network-IRC Bot'!
!IRCBotDictionary commentStamp: 'wxm 8/23/2003 17:32' prior: 0!
I provide some front end to the dictionary now. dont' expect to find no indexing or clever algorithm here though. !


!IRCBotDictionary methodsFor: 'as yet unclassified' stamp: 'wxm 8/22/2003 00:41'!
at: erg 
	| col indx mate |
	indx _ (erg copyWithoutAll: '?!!.,;') asLowercase withBlanksTrimmed.
	mate _ self
				at: indx
				ifAbsent: [].
	mate
		ifNotNil: [^ mate].
	"try as singular"
	mate _ super
				at: (indx copyUpToLast: $s) ifAbsent: [].
	mate
		ifNotNil: [^ mate].
	"try as plural"
	mate _ super
				at: indx , 's'
				ifAbsent: [].
	mate
		ifNotNil: [^ mate].
	"try abbreviation"
	(col _ indx findTokens: ' ') size > 1
		ifTrue: [indx _ ''.
			col
				do: [:nm | indx _ indx , nm first asString].
			mate _ super
						at: indx
						ifAbsent: []].
	^ mate! !

!IRCBotDictionary methodsFor: 'as yet unclassified' stamp: 'wxm 8/22/2003 00:39'!
at: key put: v 
	"a shitty wrapper"
	^ super at: (key copyWithoutAll: '!!.?,;') asLowercase withBlanksTrimmed put: v withBlanksTrimmed!
]style[(4 3 6 1 3 18 4 5 6 3 17 7 37 1 18)f4b,f4cblue;b,f4b,f4cblue;b,f4,f4c148046000,f4,f4cmagenta;,f4,f4cblue;i,f4,f4c148046000,f4,f4cblue;i,f4! !

!IRCBotDictionary methodsFor: 'as yet unclassified' stamp: 'wxm 8/21/2003 23:08'!
removeKey: key
	"a shitty wrapper"
	^ self removeKey: (key copyWithoutAll: '?!!.,;') asLowercase withBlanksTrimmed ifAbsent: []! !

!IRCBotDictionary methodsFor: 'as yet unclassified' stamp: 'wxm 8/22/2003 00:40'!
removeKey: key ifAbsent: block 
	"a shitty wrapper"
	^ super removeKey: (key copyWithoutAll: '?!!.,;') asLowercase withBlanksTrimmed ifAbsent: block! !


Object subclass: #IncomingMsg
	instanceVariableNames: 'sender channel sentence '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Network-IRC Bot'!
!IncomingMsg commentStamp: 'wxm 8/23/2003 17:33' prior: 0!
I am responsible for breaking up the incoming message even more - I also do some custom things to interface with the sq channel bridge !


!IncomingMsg methodsFor: 'accessors' stamp: 'wxm 7/29/2003 20:58'!
channel
^channel! !

!IncomingMsg methodsFor: 'accessors' stamp: 'wxm 7/29/2003 20:58'!
sender
^
	sender! !

!IncomingMsg methodsFor: 'accessors' stamp: 'wxm 7/29/2003 20:59'!
sentence
	^ sentence	! !


!IncomingMsg methodsFor: 'modifiers' stamp: 'wxm 7/29/2003 20:58'!
channel: c
	 channel _ c! !

!IncomingMsg methodsFor: 'modifiers' stamp: 'wxm 7/29/2003 20:58'!
sender: s
sender _ s! !

!IncomingMsg methodsFor: 'modifiers' stamp: 'wxm 7/29/2003 20:59'!
sentence: s
	sentence _ s! !


!IncomingMsg methodsFor: 'as yet unclassified' stamp: 'wxm 7/29/2003 21:18'!
argumentsToCommand
^sentence copyFrom: 3 to: (sentence size)! !

!IncomingMsg methodsFor: 'as yet unclassified' stamp: 'wxm 7/29/2003 20:48'!
command
sentence isEmptyOrNil ifFalse: [^sentence at: 2].
^nil! !

!IncomingMsg methodsFor: 'as yet unclassified' stamp: 'wxm 7/29/2003 20:49'!
salutation
	sentence isEmptyOrNil
		ifFalse: [^ sentence at: 1].
	^ nil! !

!IncomingMsg methodsFor: 'as yet unclassified' stamp: 'wxm 9/11/2003 18:19'!
testForSq
	"a hack to recognize messages from the sq ----  
	ideally the IRCBot will also take care of sq's responsibilities - for 
	now it just does abi's"
	"a hack^"
	| bid |
	sentence isEmptyOrNil ifFalse: [
	((bid _ sentence first) first = $<
			and: [(bid findString: '@')
						> 0
					and: [bid last = $>]])
		ifTrue: [sentence remove: bid.
			self
				sender: ((bid copyAfter: $<)
						copyUpTo: $@)]]!
]style[(9 2 156 3 4 40 3 3 8 16 2 11 3 13 3 10 1 12 3 8 2 15 8 9 3 5 4 15 3 12 2 18 2 3)f2b,f2,f2c150048000,f2,f2cblue;i,f2,f2cblue;i,f2,f2cmagenta;,f2,f2c150048000,f2,f2cblue;i,f2,f2c150048000,f2,f2c150048000,f2,f2cblue;i,f2,f2c150048000,f2,f2cmagenta;,f2,f2cblue;i,f2,f2cmagenta;,f2,f2cblue;i,f2,f2c150048000,f2,f2c150048000,f2! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

IncomingMsg class
	instanceVariableNames: ''!

!IncomingMsg class methodsFor: 'as yet unclassified' stamp: 'wxm 8/18/2003 21:06'!
new: mesg 
	| arbo content |
	arbo _ super new.
	content _ mesg arguments last.
	arbo channel: mesg arguments first.
	"special case for sq messages"
	arbo
		sentence: (content findTokens: ' ').
mesg prefix
		ifNotNil: [arbo
				sender: (mesg prefix copyUpTo: $!!)].
	arbo testForSq.
	
	^ arbo! !

IRCBot initialize!