'From Squeak3.7alpha of ''11 September 2003'' [latest update: #5423] on 4 March 2004 at 10:07:15 pm'!
MorphicModel subclass: #PCArcMorph
	instanceVariableNames: 'fromRadians toRadians '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PieChart'!
TestCase subclass: #PCArcMorphTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PieChart-Tests'!

!PCArcMorphTest commentStamp: '<historical>' prior: 0!
This is the unit test for the class PCArcMorph. Unit tests are a good way to exercise the functionality of your system in a repeatable and automatic manner. They are therefore recommended if you plan to release anything. For more information, see: 
	- http://www.c2.com/cgi/wiki?UnitTest
	- http://minnow.cc.gatech.edu/squeak/1547
	- the sunit class category
!

RectangleMorph subclass: #PCPieChartMorph
	instanceVariableNames: 'portions piePortionInfos title '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PieChart'!
TestCase subclass: #PCPieChartMorphTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PieChart-Tests'!

!PCPieChartMorphTest commentStamp: '<historical>' prior: 0!
This is the unit test for the class PCPieChartMorph. Unit tests are a good way to exercise the functionality of your system in a repeatable and automatic manner. They are therefore recommended if you plan to release anything. For more information, see: 
	- http://www.c2.com/cgi/wiki?UnitTest
	- http://minnow.cc.gatech.edu/squeak/1547
	- the sunit class category
!

Object subclass: #PCPiePortionInfo
	instanceVariableNames: 'value reference color '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PieChart'!
TestCase subclass: #PCPiePortionInfoTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PieChart-Tests'!

!PCPiePortionInfoTest commentStamp: '<historical>' prior: 0!
This is the unit test for the class PCPiePortionInfo. Unit tests are a good way to exercise the functionality of your system in a repeatable and automatic manner. They are therefore recommended if you plan to release anything. For more information, see: 
	- http://www.c2.com/cgi/wiki?UnitTest
	- http://minnow.cc.gatech.edu/squeak/1547
	- the sunit class category
!

PCArcMorph subclass: #PCPiePortionMorph
	instanceVariableNames: 'piePortionInfo pie label '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PieChart'!
TestCase subclass: #PCPiePortionMorphTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PieChart-Tests'!

!PCPiePortionMorphTest commentStamp: '<historical>' prior: 0!
This is the unit test for the class PCPiePortionMorph. Unit tests are a good way to exercise the functionality of your system in a repeatable and automatic manner. They are therefore recommended if you plan to release anything. For more information, see: 
	- http://www.c2.com/cgi/wiki?UnitTest
	- http://minnow.cc.gatech.edu/squeak/1547
	- the sunit class category
!

Object subclass: #PCSemiArc
	instanceVariableNames: 'radiansFrom radiansTo center radius vertices '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PieChart'!
TestCase subclass: #PCSemiArcTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PieChart-Tests'!

!PCSemiArcTest commentStamp: '<historical>' prior: 0!
This is the unit test for the class PCSemiArc. Unit tests are a good way to exercise the functionality of your system in a repeatable and automatic manner. They are therefore recommended if you plan to release anything. For more information, see: 
	- http://www.c2.com/cgi/wiki?UnitTest
	- http://minnow.cc.gatech.edu/squeak/1547
	- the sunit class category
!


!PCArcMorph methodsFor: 'accessing' stamp: 'gm 3/2/2004 23:44'!
color: aColor 
	"sets the receiver's color"
	super color: aColor.
	self balloonColor: aColor! !

!PCArcMorph methodsFor: 'accessing' stamp: 'gm 3/2/2004 23:47'!
fromDegrees
	"answers the origin of the arc, in degrees"
	^self fromRadians radiansToDegrees! !

!PCArcMorph methodsFor: 'accessing' stamp: 'gm 3/2/2004 23:46'!
fromDegrees: aNumber 
	"sets the origin of the arc, in degrees"
	self fromRadians: aNumber degreesToRadians! !

!PCArcMorph methodsFor: 'accessing' stamp: 'gm 3/2/2004 23:47'!
fromRadians
	"answers the origin of the arc, in radians"
	^fromRadians! !

!PCArcMorph methodsFor: 'accessing' stamp: 'gm 3/2/2004 23:46'!
fromRadians: aNumber 
	"sets the origin of the arc, in radians"
	fromRadians := aNumber! !

!PCArcMorph methodsFor: 'accessing' stamp: 'gm 3/2/2004 23:49'!
radius
	"answers the radius"
	^(self width min: self height) // 2 - self borderWidth! !

!PCArcMorph methodsFor: 'accessing' stamp: 'gm 3/2/2004 23:47'!
toDegrees
	"answers the end of the arc, in degrees"
	^self toRadians radiansToDegrees! !

!PCArcMorph methodsFor: 'accessing' stamp: 'gm 3/2/2004 23:46'!
toDegrees: aNumber 
	"sets the end of the arc, in degrees"
	self toRadians: aNumber degreesToRadians! !

!PCArcMorph methodsFor: 'accessing' stamp: 'gm 3/2/2004 23:47'!
toRadians
	"answers the end of the arc, in radians"
	^toRadians! !

!PCArcMorph methodsFor: 'accessing' stamp: 'gm 3/2/2004 23:47'!
toRadians: aNumber 
	"sets the end of the arc, in radians"
	toRadians := aNumber! !

!PCArcMorph methodsFor: 'drawing' stamp: 'gm 3/2/2004 23:45'!
drawOn: aCanvas 
	"draws the arc"
	aCanvas 
		drawPolygon: self calculateVertices
		color: self color
		borderWidth: self borderWidth
		borderColor: self borderColor! !

!PCArcMorph methodsFor: 'geometry testing' stamp: 'gm 3/2/2004 23:42'!
arcContainsPoint: aPoint 
	"answers whether the arc covered by the received contains aPoint"
	^(PolygonMorph 
		vertices: self calculateVertices
		color: Color red
		borderWidth: 1
		borderColor: Color blue) containsPoint: aPoint! !

!PCArcMorph methodsFor: 'initialization' stamp: 'gm 3/2/2004 23:45'!
defaultDiameter
	"answers the default diameter"

	^self defaultRadius * 2! !

!PCArcMorph methodsFor: 'initialization' stamp: 'gm 3/2/2004 23:45'!
defaultRadius
	"answers the default radius"
	^50! !

!PCArcMorph methodsFor: 'initialization' stamp: 'gm 3/2/2004 23:47'!
initialize
	"initializes this instance"
	super initialize.
	fromRadians := 0.
	toRadians := 2 * Float pi.
	self height: self defaultDiameter.
	self width: self defaultDiameter.
	self color: Color red.
	self borderWidth: 0! !

!PCArcMorph methodsFor: 'initialization' stamp: 'gm 3/2/2004 23:48'!
initializeFromDegrees: fromNumber toDegrees: toNumber 
	"initializes this instances using fromNumber as origin and toNumber as end"
	self initialize.
	self fromDegrees: fromNumber.
	self toDegrees: toNumber! !

!PCArcMorph methodsFor: 'printing' stamp: 'gm 3/2/2004 23:48'!
printOn: aStream 
	"Append to the argument, aStream, a sequence of characters that
	identifies the receiver."
	aStream
		nextPutAll: 'from:';
		print: fromRadians;
		nextPutAll: ' to:';
		print: toRadians! !

!PCArcMorph methodsFor: 'private' stamp: 'gm 3/2/2004 23:44'!
calculateVertices
	"calculates the vertices for the arc, using PCSemiArcs for the arc itselfs and then adding the center of the circle to close the shape"
	| vertices |
	vertices := OrderedCollection new.
	fromRadians < Float pi & (toRadians > Float pi) 
		ifTrue: 
			[vertices := OrderedCollection new.
			vertices 
				addAll: (PCSemiArc 
						radiansFrom: fromRadians
						radiansTo: Float pi
						center: self center
						radius: self radius) vertices.
			vertices 
				addAll: (PCSemiArc 
						radiansFrom: Float pi
						radiansTo: toRadians
						center: self center
						radius: self radius) vertices]
		ifFalse: 
			[vertices := (PCSemiArc 
						radiansFrom: fromRadians
						radiansTo: toRadians
						center: self center
						radius: self radius) vertices].
	vertices add: self center x @ self center y.
	^vertices! !


!PCArcMorph class methodsFor: 'instance creation' stamp: 'gm 7/9/2002 15:39'!
fromDegrees: fromNumber toDegrees: toNumber 
	^ self new initializeFromDegrees: fromNumber toDegrees: toNumber! !


!PCArcMorphTest methodsFor: 'Testing' stamp: 'gm 3/17/2003 23:56'!
testArcContainsPoint
	| arcMorph |
	arcMorph := PCArcMorph fromDegrees: 0 toDegrees: 90.
	arcMorph center: 0 @ 0;
	width: 100;
	height: 100;
	borderWidth: 0.
	self assert: (arcMorph arcContainsPoint: 0 @ 0).
	self assert: (arcMorph arcContainsPoint: 50 @ 0).
	self assert: (arcMorph arcContainsPoint: 0 @ -50).
	self deny: (arcMorph arcContainsPoint: 50 @ -50).
	self assert: (arcMorph arcContainsPoint: 25 @ -25)! !

!PCArcMorphTest methodsFor: 'Testing' stamp: 'gm 3/26/2003 21:45'!
testCalculateVertices
	| arcMorph |
	arcMorph _ PCArcMorph fromDegrees: 0 toDegrees: 90.
	arcMorph center: 0 @ 0;
		 width: 100;
		 height: 100;
		 borderWidth: 0.
	self assert: arcMorph calculateVertices = {50.0 @ 0. 50 @ 0. 49 @ -10. 48 @ -14. 47 @ -17. 46 @ -20. 45 @ -22. 44 @ -24. 43 @ -26. 42 @ -27. 41 @ -29. 40 @ -30. 39 @ -31. 38 @ -32. 37 @ -34. 36 @ -35. 35 @ -36. 34 @ -37. 33 @ -38. 32 @ -38. 31 @ -39. 30 @ -40. 29 @ -41. 28 @ -41. 27 @ -42. 26 @ -43. 25 @ -43. 24 @ -44. 23 @ -44. 22 @ -45. 21 @ -45. 20 @ -46. 19 @ -46. 18 @ -47. 17 @ -47. 16 @ -47. 15 @ -48. 14 @ -48. 13 @ -48. 12 @ -49. 11 @ -49. 10 @ -49. 9 @ -49. 8 @ -49. 7 @ -50. 6 @ -50. 5 @ -50. 4 @ -50. 3 @ -50. 2 @ -50. 1 @ -50. 0 @ -50. 0 @ 0} asOrderedCollection!
]style[(21 3 9 4 8 3 10 14 1 12 2 3 8 9 1 3 1 12 3 13 3 18 1 3 4 9 8 22 4 3 1 2 2 3 1 2 2 3 3 2 2 3 3 2 2 3 3 2 2 3 3 2 2 3 3 2 2 3 3 2 2 3 3 2 2 3 3 2 2 3 3 2 2 3 3 2 2 3 3 2 2 3 3 2 2 3 3 2 2 3 3 2 2 3 3 2 2 3 3 2 2 3 3 2 2 3 3 2 2 3 3 2 2 3 3 2 2 3 3 2 2 3 3 2 2 3 3 2 2 3 3 2 2 3 3 2 2 3 3 2 2 3 3 2 2 3 3 2 2 3 3 2 2 3 3 2 2 3 3 2 2 3 3 2 2 3 3 2 2 3 3 2 2 3 3 2 2 3 3 2 2 3 3 2 2 3 3 2 2 3 3 2 2 3 3 2 1 3 3 2 1 3 3 2 1 3 3 2 1 3 3 2 1 3 3 2 1 3 3 2 1 3 3 2 1 3 3 2 1 3 3 6 3 2 1 3 1 21)f1b,f1,f1cblue;i,f1,f1cblue;i,f1,f1cmagenta;,f1,f1c202202126,f1,f1c202202126,f1,f1cblue;i,f1,f1c202202126,f1,f1c202202126,f1,f1c202202126,f1,f1c202202126,f1,f1c202202126,f1,f1cmagenta;,f1,f1cblue;i,f1,f1c202202126,f1,f1c202202126,f1,f1c202202126,f1,f1c202202126,f1,f1c202202126,f1,f1c202202126,f1,f1c202202126,f1,f1c202202126,f1,f1c202202126,f1,f1c202202126,f1,f1c202202126,f1,f1c202202126,f1,f1c202202126,f1,f1c202202126,f1,f1c202202126,f1,f1c202202126,f1,f1c202202126,f1,f1c202202126,f1,f1c202202126,f1,f1c202202126,f1,f1c202202126,f1,f1c202202126,f1,f1c202202126,f1,f1c202202126,f1,f1c202202126,f1,f1c202202126,f1,f1c202202126,f1,f1c202202126,f1,f1c202202126,f1,f1c202202126,f1,f1c202202126,f1,f1c202202126,f1,f1c202202126,f1,f1c202202126,f1,f1c202202126,f1,f1c202202126,f1,f1c202202126,f1,f1c202202126,f1,f1c202202126,f1,f1c202202126,f1,f1c202202126,f1,f1c202202126,f1,f1c202202126,f1,f1c202202126,f1,f1c202202126,f1,f1c202202126,f1,f1c202202126,f1,f1c202202126,f1,f1c202202126,f1,f1c202202126,f1,f1c202202126,f1,f1c202202126,f1,f1c202202126,f1,f1c202202126,f1,f1c202202126,f1,f1c202202126,f1,f1c202202126,f1,f1c202202126,f1,f1c202202126,f1,f1c202202126,f1,f1c202202126,f1,f1c202202126,f1,f1c202202126,f1,f1c202202126,f1,f1c202202126,f1,f1c202202126,f1,f1c202202126,f1,f1c202202126,f1,f1c202202126,f1,f1c202202126,f1,f1c202202126,f1,f1c202202126,f1,f1c202202126,f1,f1c202202126,f1,f1c202202126,f1,f1c202202126,f1,f1c202202126,f1,f1c202202126,f1,f1c202202126,f1,f1c202202126,f1,f1c202202126,f1,f1c202202126,f1,f1c202202126,f1,f1c202202126,f1,f1c202202126,f1,f1c202202126,f1,f1c202202126,f1,f1c202202126,f1,f1c202202126,f1,f1c202202126,f1,f1c202202126,f1,f1c202202126,f1,f1c202202126,f1,f1c202202126,f1,f1c202202126,f1,f1c202202126,f1,f1c202202126,f1,f1c202202126,f1,f1c202202126,f1,f1c202202126,f1,f1c202202126,f1,f1c202202126,f1,f1c202202126,f1,f1c202202126,f1,f1c202202126,f1! !

!PCArcMorphTest methodsFor: 'Testing' stamp: 'gm 3/26/2003 22:08'!
testCalculateVertices2
	| arcMorph |
	arcMorph _ PCArcMorph fromDegrees: 1 toDegrees: 359.
	arcMorph center: 0 @ 0;
		 width: 100;
		 height: 100;
		 borderWidth: 0.
	self assert: arcMorph calculateVertices =  {50@-1. 50@0. 49@-10. 48@-14. 47@-17. 46@-20. 45@-22. 44@-24. 43@-26. 42@-27. 41@-29. 40@-30. 39@-31. 38@-32. 37@-34. 36@-35. 35@-36. 34@-37. 33@-38. 32@-38. 31@-39. 30@-40. 29@-41. 28@-41. 27@-42. 26@-43. 25@-43. 24@-44. 23@-44. 22@-45. 21@-45. 20@-46. 19@-46. 18@-47. 17@-47. 16@-47. 15@-48. 14@-48. 13@-48. 12@-49. 11@-49. 10@-49. 9@-49. 8@-49. 7@-50. 6@-50. 5@-50. 4@-50. 3@-50. 2@-50. 1@-50. -1@-50. -2@-50. -3@-50. -4@-50. -5@-50. -6@-50. -7@-50. -8@-49. -9@-49. -10@-49. -11@-49. -12@-49. -13@-48. -14@-48. -15@-48. -16@-47. -17@-47. -18@-47. -19@-46. -20@-46. -21@-45. -22@-45. -23@-44. -24@-44. -25@-43. -26@-43. -27@-42. -28@-41. -29@-41. -30@-40. -31@-39. -32@-38. -33@-38. -34@-37. -35@-36. -36@-35. -37@-34. -38@-32. -39@-31. -40@-30. -41@-29. -42@-27. -43@-26. -44@-24. -45@-22. -46@-20. -47@-17. -48@-14. -49@-10. -50@0. -50@0. -50@0. -50@0. -49@10. -48@14. -47@17. -46@20. -45@22. -44@24. -43@26. -42@27. -41@29. -40@30. -39@31. -38@32. -37@34. -36@35. -35@36. -34@37. -33@38. -32@38. -31@39. -30@40. -29@41. -28@41. -27@42. -26@43. -25@43. -24@44. -23@44. -22@45. -21@45. -20@46. -19@46. -18@47. -17@47. -16@47. -15@48. -14@48. -13@48. -12@49. -11@49. -10@49. -9@49. -8@49. -7@50. -6@50. -5@50. -4@50. -3@50. -2@50. -1@50. 1@50. 2@50. 3@50. 4@50. 5@50. 6@50. 7@50. 8@49. 9@49. 10@49. 11@49. 12@49. 13@48. 14@48. 15@48. 16@47. 17@47. 18@47. 19@46. 20@46. 21@45. 22@45. 23@44. 24@44. 25@43. 26@43. 27@42. 28@41. 29@41. 30@40. 31@39. 32@38. 33@38. 34@37. 35@36. 36@35. 37@34. 38@32. 39@31. 40@30. 41@29. 42@27. 43@26. 44@24. 45@22. 46@20. 47@17. 48@14. 49@10. 50@0. 50@1. 0@0} asOrderedCollection! !

!PCArcMorphTest methodsFor: 'Testing' stamp: 'gm 2/21/2003 23:52'!
testColor
	| arcMorph |
	arcMorph _ PCArcMorph fromDegrees: 10 toDegrees: 80.
	arcMorph color: Color red.
	self assert: arcMorph color = Color red.
	self assert: arcMorph balloonColor = Color red.
	arcMorph color: Color blue.
	self assert: arcMorph color = Color blue.
	self assert: arcMorph balloonColor = Color blue.
! !

!PCArcMorphTest methodsFor: 'Testing' stamp: 'gm 2/21/2003 23:48'!
testCreation
	| arcMorph |
	arcMorph _ PCArcMorph fromDegrees: 10 toDegrees: 20.
	self assert: arcMorph fromDegrees = 10.
	self assert: arcMorph toDegrees = 20.
	self assert: arcMorph fromRadians = 10 degreesToRadians.
	self assert: arcMorph toRadians = 20 degreesToRadians! !

!PCArcMorphTest methodsFor: 'Testing' stamp: 'gm 2/23/2003 21:19'!
testDefaults
	| arcMorph |
	arcMorph _ PCArcMorph fromDegrees: 0 toDegrees: 90.
	self assert: arcMorph defaultDiameter > 0.
	self assert: arcMorph defaultRadius > 0.
	self assert: arcMorph defaultDiameter = (arcMorph defaultRadius * 2).
! !

!PCArcMorphTest methodsFor: 'Testing' stamp: 'gm 2/21/2003 23:49'!
testFromDegress
	| arcMorph |
	arcMorph _ PCArcMorph fromDegrees: 10 toDegrees: 80.
	arcMorph fromDegrees: 20.
	self assert: arcMorph fromDegrees = 20.
	self assert: arcMorph fromRadians = 20 degreesToRadians.
! !

!PCArcMorphTest methodsFor: 'Testing' stamp: 'gm 2/21/2003 23:50'!
testFromRadians
	| arcMorph |
	arcMorph _ PCArcMorph fromDegrees: 10 toDegrees: 80.
	arcMorph fromRadians: 20 degreesToRadians.
	self assert: arcMorph fromDegrees = 20.
	self assert: arcMorph fromRadians = 20 degreesToRadians! !

!PCArcMorphTest methodsFor: 'Testing' stamp: 'gm 3/17/2003 23:56'!
testRadius
	| arcMorph |
	arcMorph := PCArcMorph fromDegrees: 0 toDegrees: 90.
	arcMorph width: 100;
	height: 100;
	borderWidth: 0.
	self assert: arcMorph radius = 50.
	arcMorph width: 50.
	self assert: arcMorph radius = 25.
	arcMorph width: 100.
	self assert: arcMorph radius = 50.
	arcMorph height: 50.
	self assert: arcMorph radius = 25.
	arcMorph height: 100.
	self assert: arcMorph radius = 50.
	arcMorph borderWidth: 1.
	self assert: arcMorph radius = 49.
	arcMorph borderWidth: 10.
	self assert: arcMorph radius = 40! !

!PCArcMorphTest methodsFor: 'Testing' stamp: 'gm 2/21/2003 23:49'!
testToDegress
	| arcMorph |
	arcMorph _ PCArcMorph fromDegrees: 10 toDegrees: 80.
	arcMorph toDegrees: 70.
	self assert: arcMorph toDegrees = 70.
	self assert: arcMorph toRadians = 70 degreesToRadians! !

!PCArcMorphTest methodsFor: 'Testing' stamp: 'gm 2/21/2003 23:50'!
testToRadians
	| arcMorph |
	arcMorph _ PCArcMorph fromDegrees: 10 toDegrees: 80.
	arcMorph toRadians: 70 degreesToRadians.
	self assert: arcMorph toDegrees = 70.
	self assert: arcMorph toRadians = 70 degreesToRadians! !


!PCPieChartMorph methodsFor: 'accessing' stamp: 'gm 3/3/2004 00:23'!
addValue: aNumber 
	"adds a new pie with the value aNumber"
	piePortionInfos add: (PCPiePortionInfo value: aNumber).
	self updateColors: self defaultColors.
	self recalculate! !

!PCPieChartMorph methodsFor: 'accessing' stamp: 'gm 3/3/2004 00:24'!
addValue: aNumber reference: aString color: aColor 
	"adds a new pie with the specified value, reference and color"
	piePortionInfos add: (PCPiePortionInfo 
				value: aNumber
				reference: aString
				color: aColor).
	self recalculate! !

!PCPieChartMorph methodsFor: 'accessing' stamp: 'gm 3/3/2004 00:26'!
alpha: aNumber 
	"sets the alpha for all the pie portions"
	piePortionInfos do: [:each | each color: (each color alpha: aNumber)].
	self updatePortionsPortionInfo! !

!PCPieChartMorph methodsFor: 'accessing' stamp: 'gm 3/3/2004 00:27'!
balloonColorFor: aPCPiePortionMorph 
	"answers the balloon color for the specified portion, or the default if it is nil."
	^aPCPiePortionMorph isNil 
		ifTrue: [self defaultBalloonColor]
		ifFalse: [aPCPiePortionMorph piePortionInfo color]! !

!PCPieChartMorph methodsFor: 'accessing' stamp: 'gm 3/4/2004 14:06'!
balloonTextFor: aPCPiePortionMorph ifNil: aString
	"answers the balloon text for the specified portion, or the pie balloon 
	text if it is nil."
	^ aPCPiePortionMorph isNil
		ifTrue: [aString]
		ifFalse: [aPCPiePortionMorph portionBalloonText]! !

!PCPieChartMorph methodsFor: 'accessing' stamp: 'gm 3/3/2004 00:31'!
colors
	"answers the colors of the pie portions"
	^piePortionInfos collect: [:each | each color]! !

!PCPieChartMorph methodsFor: 'accessing' stamp: 'gm 3/3/2004 00:32'!
colors: aCollection 
	"sets the colors of the pie portions"
	self updateColors: aCollection.
	self updatePortionsPortionInfo! !

!PCPieChartMorph methodsFor: 'accessing' stamp: 'gm 3/3/2004 08:51'!
hideLabels
	"hides all labels"
	portions do: [:each | each hideLabel]! !

!PCPieChartMorph methodsFor: 'accessing' stamp: 'gm 3/3/2004 00:33'!
piePortionInfos
	"answers a collection with information about the pie portions"
	^piePortionInfos! !

!PCPieChartMorph methodsFor: 'accessing' stamp: 'gm 3/3/2004 08:52'!
portions
	"answers the portions of the pie"
	^portions! !

!PCPieChartMorph methodsFor: 'accessing' stamp: 'gm 3/3/2004 00:35'!
references
	"answers the references"
	^piePortionInfos collect: [:each | each reference]! !

!PCPieChartMorph methodsFor: 'accessing' stamp: 'gm 3/3/2004 08:53'!
references: aCollection 
	"sets the references"
	self updateReferences: aCollection.
	self updatePortionsPortionInfo! !

!PCPieChartMorph methodsFor: 'accessing' stamp: 'gm 3/3/2004 08:51'!
showLabels
	"shows all labels"
	portions do: [:each | each showLabel]! !

!PCPieChartMorph methodsFor: 'accessing' stamp: 'gm 3/3/2004 00:35'!
size
	"answers the amount of portions in the pie"
	^piePortionInfos size! !

!PCPieChartMorph methodsFor: 'accessing' stamp: 'gm 3/3/2004 00:37'!
sum
	"answers the accumulated absolute value of all the pie portions"
	^piePortionInfos sum value! !

!PCPieChartMorph methodsFor: 'accessing' stamp: 'gm 3/3/2004 00:37'!
title
	"answers the content of the title"
	^title contents! !

!PCPieChartMorph methodsFor: 'accessing' stamp: 'gm 3/3/2004 00:37'!
title: aString 
	"sets the content of the title"
	title contents: aString.
	self changed! !

!PCPieChartMorph methodsFor: 'accessing' stamp: 'gm 3/3/2004 00:38'!
titleHeight
	"calculates the heigth of the title"
	^title contents isEmpty ifTrue: [0] ifFalse: [title height]! !

!PCPieChartMorph methodsFor: 'accessing' stamp: 'gm 3/3/2004 23:57'!
updateColors: aCollection 
	"updates the pie portions's colors, ensuring there is enough pie portions"

	self ensurePiePortionInfosSize: aCollection size.
	piePortionInfos with: aCollection asOrderedCollection
		do: [:eachPiePortionInfo :eachColor | eachPiePortionInfo color: eachColor]! !

!PCPieChartMorph methodsFor: 'accessing' stamp: 'gm 3/3/2004 23:57'!
updateReferences: aCollection 
	"updates the pie portions's references, ensuring there is enough pie portions"

	self ensurePiePortionInfosSize: aCollection size.
	piePortionInfos with: aCollection asOrderedCollection
		do: [:eachPiePortionInfo :eachReference | eachPiePortionInfo reference: eachReference]! !

!PCPieChartMorph methodsFor: 'accessing' stamp: 'gm 3/3/2004 23:57'!
updateValues: aCollection 
	"updates the pie portions's values, ensuring there is enough pie portions"

	self ensurePiePortionInfosSize: aCollection size.
	piePortionInfos with: aCollection asOrderedCollection
		do: [:eachPiePortionInfo :eachValue | eachPiePortionInfo value: eachValue]! !

!PCPieChartMorph methodsFor: 'accessing' stamp: 'gm 3/3/2004 07:58'!
values
	"answers the values of the pie portions"
	^ piePortionInfos
		collect: [:each | each value]! !

!PCPieChartMorph methodsFor: 'accessing' stamp: 'gm 3/3/2004 07:58'!
values: aCollection 
	"sets the values of the pie portions"
	self updateValues: aCollection.
	self recalculate! !

!PCPieChartMorph methodsFor: 'accessing' stamp: 'gm 3/3/2004 07:59'!
wheelColor: aColor 
	"resets the color of the pie portions using the wheel color from aColor"
	self colors: (aColor wheel: self size)! !

!PCPieChartMorph methodsFor: 'change reporting' stamp: 'gm 3/3/2004 00:31'!
changed
	"the receiver has changed, update the size of the components so they look right"
	portions do: 
			[:each | 
			each width: self portionWidth.
			each height: self portionHeight.
			each left: self portionLeft.
			each top: self portionTop].
	title top: self titleTop.
	title left: self titleLeft.
	^super changed! !

!PCPieChartMorph methodsFor: 'initialization' stamp: 'gm 3/3/2004 08:49'!
defaultBorderForPie
	"answers the default border size for the pie"
	^5! !

!PCPieChartMorph methodsFor: 'initialization' stamp: 'gm 3/3/2004 08:49'!
defaultColors
	"answers the default colors"
	^(self defaultWheelColor wheel: self size) asOrderedCollection! !

!PCPieChartMorph methodsFor: 'initialization' stamp: 'gm 3/3/2004 08:49'!
defaultDiameter
	"answers the default diameter"
	^self defaultRadius * 2! !

!PCPieChartMorph methodsFor: 'initialization' stamp: 'gm 3/3/2004 08:49'!
defaultRadius
	"answers the default radius"
	^50! !

!PCPieChartMorph methodsFor: 'initialization' stamp: 'gm 3/3/2004 08:49'!
defaultTitleHeight
	"answers the default title height"
	^20! !

!PCPieChartMorph methodsFor: 'initialization' stamp: 'gm 3/3/2004 08:50'!
defaultWheelColor
	"answers the default wheel color"
	^Color cyan! !

!PCPieChartMorph methodsFor: 'initialization' stamp: 'gm 3/3/2004 00:32'!
initialize
	"initializes this instance"
	super initialize.
	piePortionInfos := OrderedCollection new.
	portions := OrderedCollection new.
	title := StringMorph contents: ''.
	self
		addMorph: title;
		borderWidth: 0;
		height: self defaultDiameter + self defaultTitleHeight;
		width: self defaultDiameter;
		color: Color transparent;
		balloonTextSelector: #title! !

!PCPieChartMorph methodsFor: 'initialization' stamp: 'gm 3/3/2004 00:32'!
initializeValues: aCollection 
	"initializes this instance with the specified values"
	self initialize.
	self updateValues: aCollection.
	self updateColors: self defaultColors.
	self recalculate! !

!PCPieChartMorph methodsFor: 'initialization' stamp: 'gm 3/3/2004 00:32'!
initializeValues: valuesCollection references: referencesCollection colors: colorsCollection 
	"initializes this instance with the specified values, references and colors"
	self initialize.
	self updateValues: valuesCollection.
	self updateReferences: referencesCollection.
	self updateColors: colorsCollection.
	self recalculate! !

!PCPieChartMorph methodsFor: 'private' stamp: 'gm 3/3/2004 08:37'!
addPortions
	"removes all submorphs and then adds the title and the pie portions"
	self removeAllMorphs.
	self addMorph: title.
	portions do: [:each | self addMorph: each]! !

!PCPieChartMorph methodsFor: 'private' stamp: 'gm 3/3/2004 00:25'!
adjustValues: valuesCollection 
	"adjust the absolute values to relative values in the circle"
	| total |
	total := valuesCollection sum.
	^valuesCollection collect: [:each | each / total * 360]! !

!PCPieChartMorph methodsFor: 'private' stamp: 'gm 3/4/2004 14:07'!
balloonText
	"answers the balloon text."
	"tries to guess the pointed portion based on the cursor position."
	| pointed |
	pointed _ portions
				detect: [:each | each arcContainsPoint: self cursorPoint]
				ifNone: [].
	self
		balloonColor: (self balloonColorFor: pointed).
	^ self balloonTextFor: pointed ifNil: super balloonText! !

!PCPieChartMorph methodsFor: 'private' stamp: 'gm 3/3/2004 00:30'!
calculatePortions
	"generates the pie portions based on the specified values"
	| portion |
	portions := OrderedCollection new.
	(self adjustValues: self values) inject: 0
		into: 
			[:sum :each | 
			portion := PCPiePortionMorph new.
			portion
				borderWidth: 0;
				width: self portionWidth;
				height: self portionHeight;
				fromDegrees: sum;
				toDegrees: sum + each;
				pie: self.
			portions add: portion.
			sum + each]! !

!PCPieChartMorph methodsFor: 'private' stamp: 'gm 3/3/2004 08:50'!
ensurePiePortionInfosSize: aNumber 
	"ensures that there are enough pie portion info elements"

	[piePortionInfos size < aNumber] 
		whileTrue: [piePortionInfos add: PCPiePortionInfo new]! !

!PCPieChartMorph methodsFor: 'private' stamp: 'gm 3/3/2004 00:34'!
portionHeight
	"calculates the height of the circle containing each portion"
	^self height - (self defaultBorderForPie * 2) - self defaultTitleHeight! !

!PCPieChartMorph methodsFor: 'private' stamp: 'gm 3/3/2004 00:34'!
portionLeft
	"calculates the left of the circle containing each portion"
	^self left + ((self width - self portionWidth) / 2) asInteger! !

!PCPieChartMorph methodsFor: 'private' stamp: 'gm 3/3/2004 00:34'!
portionTop
	"calculates the top of the circle containing each portion"

	^self top + self titleHeight 
		+ ((self height - self portionHeight) / 2) asInteger! !

!PCPieChartMorph methodsFor: 'private' stamp: 'gm 3/3/2004 00:34'!
portionWidth
	"calculates the width of the circle containing each portion"

	^self width - (self defaultBorderForPie * 2)! !

!PCPieChartMorph methodsFor: 'private' stamp: 'gm 3/3/2004 08:52'!
recalculate
	"recalculates all the pie portions from scratch and then adds them to the pie"
	self calculatePortions.
	self updatePortionsPortionInfo.
	self addPortions! !

!PCPieChartMorph methodsFor: 'private' stamp: 'gm 3/3/2004 00:37'!
titleLeft
	"calculates the left of the title"
	^self left + ((self width - title width) / 2) asInteger! !

!PCPieChartMorph methodsFor: 'private' stamp: 'gm 3/3/2004 00:38'!
titleTop
	"calculates the top of the title"
	^self top + 5! !

!PCPieChartMorph methodsFor: 'private' stamp: 'gm 3/3/2004 23:57'!
updatePortionsPortionInfo
	"updates the pie portion info for each pie portion"
	portions with: piePortionInfos
		do: [:portion :piePortionInfo | portion piePortionInfo: piePortionInfo]! !


!PCPieChartMorph class methodsFor: 'instance creation' stamp: 'gm 7/9/2002 15:39'!
values: aCollection 
	^ self new initializeValues: aCollection! !

!PCPieChartMorph class methodsFor: 'instance creation' stamp: 'gm 8/10/2002 16:11'!
values: aCollection references: referencesCollection colors: colorsCollection 
	^ self new initializeValues: aCollection references: referencesCollection colors: colorsCollection ! !

!PCPieChartMorph class methodsFor: 'testing' stamp: 'gm 2/21/2003 23:14'!
test1
	| pie |
	pie := PCPieChartMorph values: { 
						5.
						3.
						2.
						1.
						5.
						6.
						7.
						2.
						5.
						3.
						3}.
	pie title: 'a Pie!!'.
	pie openInWorld.
	^pie! !

!PCPieChartMorph class methodsFor: 'testing' stamp: 'gm 3/17/2003 21:32'!
test2
	| pie |
	pie _ PCPieChartMorph values: {55. 26. 15. 36}.
	pie references: {'A'. 'B'. 'C'. 'D'}.
	pie colors: {Color red. Color green. Color blue. Color yellow}.
	pie alpha: 0.5.
	pie showLabels.
	pie openInWorld.
	^ pie! !

!PCPieChartMorph class methodsFor: 'testing' stamp: 'gm 3/17/2003 23:30'!
test3
	| pie |
	pie _ PCPieChartMorph values: {45. 26. 20. 36}.
	pie
		color: (Color blue twiceDarker twiceDarker twiceDarker alpha: 0.3);
		 references: {'Banana'. 'Apple'. 'Orange'. 'Kiwi'};
		 colors: {Color yellow. Color red. Color orange. Color green};
		title: 'Fruits';
		 alpha: 0.5;
		 extent: 200 @ 220;
		 useRoundedCorners;
		 borderWidth: 2;
		 showLabels;
		 openInWorld.
	^ pie! !

!PCPieChartMorph class methodsFor: 'testing' stamp: 'gm 2/21/2003 23:14'!
test4
	| pie |
	pie := PCPieChartMorph 
				values: { 
						50.
						50.
						50.
						50}
				references: { 
						'A'.
						'B'.
						'C'.
						'D'}
				colors: { 
						Color red.
						Color green.
						Color blue.
						Color yellow}.
	pie 
		addValue: 50
		reference: 'E'
		color: Color cyan.
	pie 
		addValue: 50
		reference: 'F'
		color: Color orange.
	pie openInWorld.
	^pie! !


!PCPieChartMorphTest methodsFor: 'Testing' stamp: 'gm 3/11/2003 22:18'!
testAddValue
	| pie values |
	values _ {50. 60. 70. 30} asOrderedCollection.
	pie _ PCPieChartMorph values: values.
	self assert: pie values = values.
	self assert: pie portions size = 4.
	pie addValue: 40.
	self assert: pie values
			= (values copyWith: 40).
	self assert: pie portions size = 5.
	self assert: pie portions last piePortionInfo value = 40! !

!PCPieChartMorphTest methodsFor: 'Testing' stamp: 'gm 3/11/2003 22:14'!
testAddValueReferenceColor
	| pie values references colors |
	values _ {50. 60. 70. 30} asOrderedCollection.
	references _ {'A'. 'B'. 'C'. 'D'} asOrderedCollection.
	colors _ {Color red. Color green. Color blue. Color yellow} asOrderedCollection.
	pie _ PCPieChartMorph
				values: values
				references: references
				colors: colors.
	self assert: pie values = values.
	self assert: pie references = references.
	self assert: pie colors = colors.
	self assert: pie portions size = 4.
	pie
		addValue: 40
		reference: 'E'
		color: Color brown.
	self assert: pie values
			= (values copyWith: 40).
	self assert: pie references
			= (references copyWith: 'E').
	self assert: pie colors
			= (colors copyWith: Color brown).
	self assert: pie portions size = 5.
	self assert: pie portions last piePortionInfo value = 40.
	self assert: pie portions last piePortionInfo reference = 'E'.
	self assert: pie portions last piePortionInfo color = Color brown! !

!PCPieChartMorphTest methodsFor: 'Testing' stamp: 'gm 3/17/2003 21:18'!
testAlpha
	| pie |
	pie _ PCPieChartMorph values: {5. 3. 2} asOrderedCollection.
	pie alpha: 0.5.
	self assert: (pie portions first piePortionInfo color alpha - 0.5) abs < 0.01.
	self assert: (pie portions second piePortionInfo color alpha - 0.5) abs < 0.01.
	self assert: (pie portions third piePortionInfo color alpha - 0.5) abs < 0.01.
	pie alpha: 0.8.
	self assert: (pie portions first piePortionInfo color alpha - 0.8) abs < 0.01.
	self assert: (pie portions second piePortionInfo color alpha - 0.8) abs < 0.01.
	self assert: (pie portions third piePortionInfo color alpha - 0.8) abs < 0.01! !

!PCPieChartMorphTest methodsFor: 'Testing' stamp: 'gm 3/10/2003 06:32'!
testBalloonColorFor
	| pie |
	pie _ PCPieChartMorph values: {5. 3. 2} asOrderedCollection.
	pie colors: {Color red. Color green. Color blue}.
	self assert: (pie balloonColorFor: pie portions first)
			= Color red.
	self assert: (pie balloonColorFor: pie portions second)
			= Color green.
	self assert: (pie balloonColorFor: pie portions third)
			= Color blue.
	self assert: (pie balloonColorFor: nil)
			= pie defaultBalloonColor! !

!PCPieChartMorphTest methodsFor: 'Testing' stamp: 'gm 3/4/2004 14:07'!
testBalloonTextFor
	| pie |
	pie _ PCPieChartMorph values: {3. 2} asOrderedCollection.
	self assert: (pie balloonTextFor: pie portions first ifNil: '')
			= '3 - 60%'.
	self assert: (pie balloonTextFor: pie portions second ifNil: '')
			= '2 - 40%'.
	self assert: (pie balloonTextFor: nil ifNil: 'title')
			= 'title'! !

!PCPieChartMorphTest methodsFor: 'Testing' stamp: 'gm 3/15/2003 02:31'!
testColors
	| pie colors |
	pie _ PCPieChartMorph values: {5. 3. 2}.
	colors _ {Color red. Color green. Color blue} asOrderedCollection.
	pie colors: colors.
	self assert: pie colors = colors.
	self assert: pie portions first piePortionInfo color = Color red.
	self assert: pie portions second piePortionInfo color = Color green.
	self assert: pie portions third piePortionInfo color = Color blue! !

!PCPieChartMorphTest methodsFor: 'Testing' stamp: 'gm 2/25/2003 17:30'!
testCreationValues
	| values pie |
	values _ {5. 3. 2. 1. 6. 7} asOrderedCollection.
	pie _ PCPieChartMorph values: values.
	self assert: pie values = values.
	self assert: pie portions size = 6.
! !

!PCPieChartMorphTest methodsFor: 'Testing' stamp: 'gm 2/25/2003 17:32'!
testCreationValuesReferencesColors
	| values pie references colors |
	values _ {50. 60. 70. 30} asOrderedCollection.
	references _ {'A'. 'B'. 'C'. 'D'} asOrderedCollection.
	colors _ {Color red. Color green. Color blue. Color yellow} asOrderedCollection.
	pie _ PCPieChartMorph
				values: values
				references: references
				colors: colors.
	self assert: pie values = values.
	self assert: pie references = references.
	self assert: pie colors = colors.
	self assert: pie portions size = 4
! !

!PCPieChartMorphTest methodsFor: 'Testing' stamp: 'gm 3/17/2003 21:20'!
testEnsurePiePortionInfosSize
	| pie |
	pie _ PCPieChartMorph values: {5. 3. 2} asOrderedCollection.
	self assert: pie piePortionInfos size = 3.
	pie 	ensurePiePortionInfosSize: 5.
	self assert: pie piePortionInfos size = 5.
! !

!PCPieChartMorphTest methodsFor: 'Testing' stamp: 'gm 3/4/2004 19:55'!
testHideLabels
	| pie references |
	pie _ PCPieChartMorph values: {5. 3. 2}.
	references _ {'A'. 'B'. 'C'} asOrderedCollection.
	pie references: references.
	pie showLabels.
	pie portions
		do: [:each | self assert: each submorphs notEmpty].
	pie hideLabels.
	pie portions
		do: [:each | self assert: each submorphs isEmpty]! !

!PCPieChartMorphTest methodsFor: 'Testing' stamp: 'gm 3/15/2003 02:32'!
testReferences
	| pie references |
	pie _ PCPieChartMorph values: {5. 3. 2} .
	references _ {'A'. 'B'. 'C'} asOrderedCollection.
	pie references: references.
	self assert: pie references = references.
	self assert: pie portions first piePortionInfo reference = 'A'.
	self assert: pie portions second piePortionInfo reference = 'B'.
	self assert: pie portions third piePortionInfo reference = 'C'! !

!PCPieChartMorphTest methodsFor: 'Testing' stamp: 'gm 3/10/2003 06:36'!
testSize
	| pie |
	pie _ PCPieChartMorph values: {1. 2. 3} asOrderedCollection.
	self assert: pie size = 3.
	pie
		addValue: 4.
	self assert: pie size = 4.

! !

!PCPieChartMorphTest methodsFor: 'Testing' stamp: 'gm 3/11/2003 09:38'!
testSum
	| pie |
	pie _ PCPieChartMorph values: {1. 2. 3} asOrderedCollection.
	self assert: pie sum = 6.
	pie addValue: 4.
	self assert: pie sum = 10! !

!PCPieChartMorphTest methodsFor: 'Testing' stamp: 'gm 3/10/2003 01:10'!
testTitle
	| pie |
	pie _ PCPieChartMorph new.
	pie title: 'test1'.
	self assert: pie title = 'test1'.
	pie title: 'test2'.
	self assert: pie title = 'test2'! !

!PCPieChartMorphTest methodsFor: 'Testing' stamp: 'gm 3/10/2003 01:12'!
testTitleHeight
	| pie |
	pie _ PCPieChartMorph new.
	pie title: ''.
	self assert: pie titleHeight = 0.
	pie title: 'test'.
	self assert: pie titleHeight > 0! !

!PCPieChartMorphTest methodsFor: 'Testing' stamp: 'gm 3/11/2003 22:18'!
testValues
	| pie |
	pie _ PCPieChartMorph values: {1. 2. 3} asOrderedCollection.
	self assert: pie portions first piePortionInfo value = 1.
	self assert: pie portions second piePortionInfo value = 2.
	self assert: pie portions third piePortionInfo value = 3.
	pie values: {6. 5. 4} asOrderedCollection.
	self assert: pie portions first piePortionInfo value = 6.
	self assert: pie portions second piePortionInfo value = 5.
	self assert: pie portions third piePortionInfo value = 4! !

!PCPieChartMorphTest methodsFor: 'Testing' stamp: 'gm 3/12/2003 23:54'!
testValuesSizeChange
	| pie |
	pie _ PCPieChartMorph values: {1. 2. 3} asOrderedCollection.
	self assert: pie portions first piePortionInfo value = 1.
	self assert: pie portions second piePortionInfo value = 2.
	self assert: pie portions third piePortionInfo value = 3.
	pie values: {7. 6. 5. 4} asOrderedCollection.
	self assert: pie portions first piePortionInfo value = 7.
	self assert: pie portions second piePortionInfo value = 6.
	self assert: pie portions third piePortionInfo value = 5.
	self assert: pie portions last piePortionInfo value = 4!
]style[(20 3 4 4 3 3 15 10 1 2 1 2 1 24 4 9 3 39 1 3 4 9 3 40 1 3 4 9 3 39 1 3 3 10 4 2 1 2 1 24 4 9 3 39 1 3 4 9 3 40 1 3 4 9 3 39 1 3 4 9 3 38 1)f1b,f1,f1cblue;i,f1,f1cblue;i,f1,f1cmagenta;,f1,f1c198198122,f1,f1c198198122,f1,f1c198198122,f1,f1cmagenta;,f1,f1cblue;i,f1,f1c198198122,f1,f1cmagenta;,f1,f1cblue;i,f1,f1c198198122,f1,f1cmagenta;,f1,f1cblue;i,f1,f1c198198122,f1,f1cblue;i,f1,f1c198198122,f1,f1c198198122,f1,f1c198198122,f1,f1cmagenta;,f1,f1cblue;i,f1,f1c198198122,f1,f1cmagenta;,f1,f1cblue;i,f1,f1c198198122,f1,f1cmagenta;,f1,f1cblue;i,f1,f1c198198122,f1,f1cmagenta;,f1,f1cblue;i,f1,f1c198198122! !

!PCPieChartMorphTest methodsFor: 'Testing' stamp: 'gm 3/15/2003 02:37'!
testWheelColor
	| pie colors newColors |
	pie _ PCPieChartMorph values: {5. 3. 2}.
	colors _ {Color red. Color green. Color blue} asOrderedCollection.
	pie colors: colors.
	self assert: pie colors = colors.
	self assert: pie portions first piePortionInfo color = Color red.
	self assert: pie portions second piePortionInfo color = Color green.
	self assert: pie portions third piePortionInfo color = Color blue.
	newColors _ (Color yellow wheel: 3) asOrderedCollection.
	pie wheelColor: Color yellow.
	self assert: pie colors = newColors.
	self assert: pie portions first piePortionInfo color = newColors first.
	self assert: pie portions second piePortionInfo color = newColors second.
	self assert: pie portions third piePortionInfo color = newColors third!
]style[(14 3 21 4 3 3 15 10 1 2 1 2 1 4 6 4 5 6 5 8 5 29 3 9 6 3 4 9 3 10 6 3 4 9 3 39 5 7 4 9 3 40 5 9 4 9 3 39 5 8 9 4 5 15 1 24 3 13 5 10 4 9 3 10 9 3 4 9 3 39 9 9 4 9 3 40 9 10 4 9 3 39 9 6)f1b,f1,f1cblue;i,f1,f1cblue;i,f1,f1cmagenta;,f1,f1c198198122,f1,f1c198198122,f1,f1c198198122,f1,f1cblue;i,f1,f1cmagenta;,f1,f1cmagenta;,f1,f1cmagenta;,f1,f1cblue;i,f1,f1cblue;i,f1,f1cmagenta;,f1,f1cblue;i,f1,f1cblue;i,f1,f1cmagenta;,f1,f1cblue;i,f1,f1cmagenta;,f1,f1cmagenta;,f1,f1cblue;i,f1,f1cmagenta;,f1,f1cmagenta;,f1,f1cblue;i,f1,f1cmagenta;,f1,f1cblue;i,f1,f1cmagenta;,f1,f1c198198122,f1,f1cblue;i,f1,f1cmagenta;,f1,f1cmagenta;,f1,f1cblue;i,f1,f1cblue;i,f1,f1cmagenta;,f1,f1cblue;i,f1,f1cblue;i,f1,f1cmagenta;,f1,f1cblue;i,f1,f1cblue;i,f1,f1cmagenta;,f1,f1cblue;i,f1,f1cblue;i,f1! !


!PCPiePortionInfo methodsFor: 'accessing' stamp: 'gm 3/3/2004 01:00'!
color
	"answers the color"
	^color! !

!PCPiePortionInfo methodsFor: 'accessing' stamp: 'gm 3/3/2004 01:00'!
color: aColor 
	"sets the color"
	color := aColor! !

!PCPiePortionInfo methodsFor: 'accessing' stamp: 'gm 3/3/2004 00:59'!
reference
	"answers the reference"
	^reference! !

!PCPiePortionInfo methodsFor: 'accessing' stamp: 'gm 3/3/2004 01:00'!
reference: aString 
	"sets the reference"
	reference := aString! !

!PCPiePortionInfo methodsFor: 'accessing' stamp: 'gm 3/3/2004 01:00'!
value
	"answers the value"
	^value! !

!PCPiePortionInfo methodsFor: 'accessing' stamp: 'gm 3/3/2004 01:00'!
value: aNumber 
	"sets the value"
	value := aNumber! !

!PCPiePortionInfo methodsFor: 'printing' stamp: 'gm 3/3/2004 00:59'!
printOn: aStream 
	"Append to the argument, aStream, a sequence of characters that 
	identifies the receiver."
	aStream nextPutAll: 'value:';
		 print: value;
		 nextPutAll: ' reference:';
		 print: reference;
		 nextPutAll: ' color:';
		 print: color! !

!PCPiePortionInfo methodsFor: 'arithmetic' stamp: 'gm 3/3/2004 01:02'!
+ aPCPiePortionInfo 
	"answers the sum of the receiver and aPCPiePortionInfo"
	^self class 
		value: value + aPCPiePortionInfo value
		reference: (reference ifNil: ['']) , '+' 
				, (aPCPiePortionInfo reference ifNil: [''])
		color: color + aPCPiePortionInfo color! !

!PCPiePortionInfo methodsFor: 'arithmetic' stamp: 'gm 3/3/2004 01:03'!
- aPCPiePortionInfo 
	"answers the difference of the receiver and aPCPiePortionInfo"
	^self class 
		value: value - aPCPiePortionInfo value
		reference: (reference ifNil: ['']) , '-' 
				, (aPCPiePortionInfo reference ifNil: [''])
		color: color - aPCPiePortionInfo color! !

!PCPiePortionInfo methodsFor: 'initializing' stamp: 'gm 3/3/2004 00:58'!
initialize
	"initializes this instance"
	value := 0.
	reference := ''.
	color := Color white! !

!PCPiePortionInfo methodsFor: 'initializing' stamp: 'gm 3/3/2004 00:58'!
initializeValue: aNumber 
	"initializes this instance with a value"
	value := aNumber! !

!PCPiePortionInfo methodsFor: 'initializing' stamp: 'gm 3/3/2004 00:58'!
initializeValue: aNumber reference: aString color: aColor 
	"initializes this instance with a value, a reference and a color"
	self initializeValue: aNumber.
	reference := aString.
	color := aColor! !


!PCPiePortionInfo class methodsFor: 'instance creation' stamp: 'gm 3/15/2003 02:22'!
new
	^ super new initialize! !

!PCPiePortionInfo class methodsFor: 'instance creation' stamp: 'gm 3/12/2003 23:58'!
value: aNumber
	^ self new
		initializeValue: aNumber
! !

!PCPiePortionInfo class methodsFor: 'instance creation' stamp: 'gm 3/12/2003 23:57'!
value: aNumber reference: aString color: aColor 
	^ self new initializeValue: aNumber reference: aString color: aColor ! !


!PCPiePortionInfoTest methodsFor: 'Testing' stamp: 'gm 3/11/2003 22:09'!
testColor
	| piePortionInfo |
	piePortionInfo _ PCPiePortionInfo new.
	piePortionInfo color: Color red.
	self assert: piePortionInfo color = Color red.
	piePortionInfo color: Color blue.
	self assert: piePortionInfo color = Color blue! !

!PCPiePortionInfoTest methodsFor: 'Testing' stamp: 'gm 3/11/2003 22:09'!
testReference
	| piePortionInfo |
	piePortionInfo _ PCPiePortionInfo new.
	piePortionInfo reference: 'A'.
	self assert: piePortionInfo reference = 'A'.
	piePortionInfo reference: 'B'.
	self assert: piePortionInfo reference = 'B'! !

!PCPiePortionInfoTest methodsFor: 'Testing' stamp: 'gm 3/11/2003 22:08'!
testValue
	| piePortionInfo |
	piePortionInfo _ PCPiePortionInfo new.
	piePortionInfo value: 2.
	self assert: piePortionInfo value = 2.
	piePortionInfo value: 8.
	self assert: piePortionInfo value = 8! !


!PCPiePortionMorph methodsFor: 'accessing' stamp: 'gm 3/3/2004 19:13'!
centerRadians
	"calculates the center angle, in radians"
	^self fromRadians + ((self toRadians - self fromRadians) / 2)! !

!PCPiePortionMorph methodsFor: 'accessing' stamp: 'gm 3/3/2004 19:13'!
color
	"answers the color"
	^piePortionInfo isNil 
		ifTrue: [self defaultColor]
		ifFalse: [piePortionInfo color]! !

!PCPiePortionMorph methodsFor: 'accessing' stamp: 'gm 3/3/2004 19:12'!
color: aColor 
	"sets the color"
	piePortionInfo notNil ifTrue: [piePortionInfo color: aColor]! !

!PCPiePortionMorph methodsFor: 'accessing' stamp: 'gm 3/3/2004 19:14'!
hideLabel
	"hides the label"
	label delete! !

!PCPiePortionMorph methodsFor: 'accessing' stamp: 'gm 3/3/2004 19:12'!
label
	"answers the label"
	^label contents! !

!PCPiePortionMorph methodsFor: 'accessing' stamp: 'gm 3/3/2004 19:12'!
label: aString 
	"sets the label"
	label contents: aString.
	self changed! !

!PCPiePortionMorph methodsFor: 'accessing' stamp: 'gm 3/3/2004 19:15'!
pie: aPCPieChartMorph 
	"sets the owner pie"
	pie := aPCPieChartMorph! !

!PCPiePortionMorph methodsFor: 'accessing' stamp: 'gm 3/3/2004 23:41'!
piePortionInfo
	"answers the pie portion info"
	^piePortionInfo! !

!PCPiePortionMorph methodsFor: 'accessing' stamp: 'gm 3/3/2004 23:41'!
piePortionInfo: aPCPiePortionInfo 
	"sets the pie portion info"
	piePortionInfo := aPCPiePortionInfo.
	piePortionInfo color notNil ifTrue: [self color: piePortionInfo color].
	piePortionInfo reference notNil 
		ifTrue: [self label: piePortionInfo reference]! !

!PCPiePortionMorph methodsFor: 'accessing' stamp: 'gm 3/3/2004 23:58'!
portionBalloonText
	"answers the balloon text for this portion, based on the reference and 
	the value"
	| text |
	piePortionInfo value isNil
		ifTrue: [^ ''].
	text _ WriteStream on: String new.
	piePortionInfo reference notNil & piePortionInfo reference notEmpty
		ifTrue: [text nextPutAll: piePortionInfo reference;
				 nextPutAll: ' - '].
	text nextPutAll: piePortionInfo value asString;
		 nextPutAll: ' - ';
		 nextPutAll: (100 * piePortionInfo value / pie sum) asInteger asString;
		 nextPutAll: '%'.
	^ text contents! !

!PCPiePortionMorph methodsFor: 'accessing' stamp: 'gm 3/3/2004 23:53'!
portionCenter
	"calculates the center of this pie portion"
	"that is, the point in the central angle of the pie, at a distance of  
	radius/2 from the center"
	"example with a big pie portion, from=10, to=280, radius=50  
	the portionCenter is: direction=145 degrees, distance from center=25"
	| portionCenterX portionCenterY distanceFromCenter |
	distanceFromCenter _ self radius / 2.
	portionCenterX _ self center x + (self centerRadians cos * distanceFromCenter).
	portionCenterY _ self center y - (self centerRadians sin * distanceFromCenter).
	^ portionCenterX @ portionCenterY! !

!PCPiePortionMorph methodsFor: 'accessing' stamp: 'gm 3/3/2004 19:14'!
showLabel
	"shows the label"
	piePortionInfo reference notNil 
		ifTrue: [self label: piePortionInfo reference].
	self addMorph: label! !

!PCPiePortionMorph methodsFor: 'initialization' stamp: 'gm 3/3/2004 23:40'!
defaultColor
	"answers the default color"
	^Color red! !

!PCPiePortionMorph methodsFor: 'initialization' stamp: 'gm 3/3/2004 23:40'!
initialize
	"initializes this instance"
	super initialize.
	piePortionInfo := PCPiePortionInfo new.
	label := StringMorph contents: ''! !

!PCPiePortionMorph methodsFor: 'printing' stamp: 'gm 3/3/2004 00:59'!
printOn: aStream 
	"Append to the argument, aStream, a sequence of characters that 
	identifies the receiver."
	super printOn: aStream.
	aStream nextPutAll: ' title:';
		 print: self portionBalloonText! !

!PCPiePortionMorph methodsFor: 'change reporting' stamp: 'gm 3/3/2004 23:40'!
changed
	"the receiver has changed, update the position of the label so it looks right"
	label notNil ifTrue: [label center: self portionCenter].
	^super changed! !


!PCPiePortionMorphTest methodsFor: 'Testing' stamp: 'gm 3/15/2003 20:20'!
testCenterRadians
	| piePortionMorph |
	piePortionMorph _ PCPiePortionMorph fromDegrees: 0 toDegrees: 90.
	self assert: (piePortionMorph centerRadians closeTo: 45 degreesToRadians).
	piePortionMorph _ PCPiePortionMorph fromDegrees: 90 toDegrees: 180.
	self assert: (piePortionMorph centerRadians closeTo: 135 degreesToRadians).
	piePortionMorph _ PCPiePortionMorph fromDegrees: 0 toDegrees: 180.
	self assert: (piePortionMorph centerRadians closeTo: 90 degreesToRadians).
	piePortionMorph _ PCPiePortionMorph fromDegrees: 120 toDegrees: 280.
	self assert: (piePortionMorph centerRadians closeTo: 200 degreesToRadians)!
]style[(17 3 16 4 15 3 17 14 1 12 2 3 4 10 15 24 2 21 15 3 17 14 2 12 3 3 4 10 15 24 3 21 15 3 17 14 1 12 3 3 4 10 15 24 2 21 15 3 17 14 3 12 3 3 4 10 15 24 3 18)f1b,f1,f1cblue;i,f1,f1cblue;i,f1,f1cmagenta;,f1,f1c198198122,f1,f1c198198122,f1,f1cmagenta;,f1,f1cblue;i,f1,f1c198198122,f1,f1cblue;i,f1,f1cmagenta;,f1,f1c198198122,f1,f1c198198122,f1,f1cmagenta;,f1,f1cblue;i,f1,f1c198198122,f1,f1cblue;i,f1,f1cmagenta;,f1,f1c198198122,f1,f1c198198122,f1,f1cmagenta;,f1,f1cblue;i,f1,f1c198198122,f1,f1cblue;i,f1,f1cmagenta;,f1,f1c198198122,f1,f1c198198122,f1,f1cmagenta;,f1,f1cblue;i,f1,f1c198198122,f1! !

!PCPiePortionMorphTest methodsFor: 'Testing' stamp: 'gm 3/17/2003 21:23'!
testColor
	| piePortionMorph piePortionInfo |
	piePortionInfo _ PCPiePortionInfo new.
	piePortionInfo color: Color blue.
	piePortionMorph _ PCPiePortionMorph new.
	piePortionMorph piePortionInfo: piePortionInfo.
	self assert: piePortionMorph color = Color blue.
	self assert: piePortionInfo color = Color blue.
	piePortionMorph color: Color red. 
	self assert: piePortionMorph color = Color red.
	self assert: piePortionInfo color = Color red.
! !

!PCPiePortionMorphTest methodsFor: 'Testing' stamp: 'gm 3/17/2003 23:55'!
testHideLabel
	| piePortionMorph |
	piePortionMorph := PCPiePortionMorph new.
	piePortionMorph label: 'A'.
	piePortionMorph showLabel.
	self assert: piePortionMorph submorphs size = 1.
	piePortionMorph hideLabel.
	self assert: piePortionMorph submorphs isEmpty! !

!PCPiePortionMorphTest methodsFor: 'Testing' stamp: 'gm 3/17/2003 21:26'!
testLabel
	| piePortionMorph piePortionInfo |
	piePortionInfo _ PCPiePortionInfo new.
	piePortionInfo reference: 'A'.
	piePortionMorph _ PCPiePortionMorph new.
	piePortionMorph piePortionInfo: piePortionInfo.
	self assert: piePortionMorph label = 'A'.
	piePortionMorph label: 'B'.
	self assert: piePortionMorph label = 'B'.
! !

!PCPiePortionMorphTest methodsFor: 'Testing' stamp: 'gm 3/17/2003 23:55'!
testLabelPosition
	| piePortionMorph |
	piePortionMorph := PCPiePortionMorph new.
	piePortionMorph label: 'A'.
	piePortionMorph showLabel.
	self assert: piePortionMorph submorphs first center 
				= piePortionMorph portionCenter! !

!PCPiePortionMorphTest methodsFor: 'Testing' stamp: 'gm 3/11/2003 12:23'!
testPortionBalloonText
	| pie |
	pie _ PCPieChartMorph values: {1. 2. 3} asOrderedCollection.
	self assert: pie portions first portionBalloonText = '1 - 16%'.
	self assert: pie portions second portionBalloonText = '2 - 33%'.
	self assert: pie portions third portionBalloonText = '3 - 50%'! !

!PCPiePortionMorphTest methodsFor: 'Testing' stamp: 'gm 3/15/2003 20:38'!
testPortionCenter
	| piePortionMorph |
	piePortionMorph _ PCPiePortionMorph fromDegrees: 0 toDegrees: 90.
	piePortionMorph borderWidth: 0.
	piePortionMorph
		bounds: (0 @ 0 extent: 100 @ 100).
	self assert: (piePortionMorph portionCenter x closeTo: 67.6776695296637).
	self assert: (piePortionMorph portionCenter y closeTo: 32.3223304703363).
!
]style[(17 3 16 4 15 3 17 14 1 12 2 3 15 14 1 3 15 12 1 3 1 9 3 3 3 4 4 10 15 46 4 10 15 45)f1b,f1,f1cblue;i,f1,f1cblue;i,f1,f1cmagenta;,f1,f1c198198122,f1,f1c198198122,f1,f1cblue;i,f1,f1c198198122,f1,f1cblue;i,f1,f1c198198122,f1,f1c198198122,f1,f1c198198122,f1,f1c198198122,f1,f1cmagenta;,f1,f1cblue;i,f1,f1cmagenta;,f1,f1cblue;i,f1! !

!PCPiePortionMorphTest methodsFor: 'Testing' stamp: 'gm 3/17/2003 23:55'!
testShowLabel
	| piePortionMorph |
	piePortionMorph := PCPiePortionMorph new.
	piePortionMorph label: 'A'.
	self assert: piePortionMorph submorphs isEmpty.
	piePortionMorph showLabel.
	self assert: piePortionMorph submorphs size = 1! !


!PCSemiArc methodsFor: 'accessing' stamp: 'gm 9/3/2003 16:18'!
center
	"Answers the center. Used only in UnitTests."
	^ center! !

!PCSemiArc methodsFor: 'accessing' stamp: 'gm 9/3/2003 16:18'!
radiansFrom
	"Answers the starting angle. Used only in UnitTests."
	^ radiansFrom! !

!PCSemiArc methodsFor: 'accessing' stamp: 'gm 9/3/2003 16:18'!
radiansTo
	"Answers the finishing angle. Used only in UnitTests."
	^ radiansTo! !

!PCSemiArc methodsFor: 'accessing' stamp: 'gm 9/3/2003 16:18'!
radius
	"Answers the radius. Used only in UnitTests."
	^ radius! !

!PCSemiArc methodsFor: 'accessing' stamp: 'gm 9/3/2003 16:21'!
vertices
	"Answers the calculated vertices for this SemiArc."
	^ vertices! !

!PCSemiArc methodsFor: 'initializing' stamp: 'gm 3/3/2004 00:50'!
initialize
	"initializes this instance"
	vertices := OrderedCollection new! !

!PCSemiArc methodsFor: 'initializing' stamp: 'gm 3/3/2004 00:51'!
initializeRadiansFrom: fromNumber radiansTo: toNumber center: aPoint radius: radiusNumber 
	"initializes this instance with from/to radians, a center and a radius"
	self initialize.
	radiansFrom := fromNumber.
	radiansTo := toNumber.
	center := aPoint.
	radius := radiusNumber.
	self calculateVertices! !

!PCSemiArc methodsFor: 'private' stamp: 'gm 9/3/2003 17:58'!
addIntermediatePoints
	"Adds the Points between From and To"
	| arcBeginX arcEndX |
	arcBeginX _ (radiansFrom cos * radius) rounded.
	arcEndX _ (radiansTo cos * radius) rounded.
	arcBeginX = arcEndX
		ifTrue: [vertices
				add: (self pointAtX: arcBeginX)]
		ifFalse: [arcBeginX
				to: arcEndX
				by: (arcEndX - arcBeginX) sign
				do: [:each | vertices
						add: (self pointAtX: each)]]! !

!PCSemiArc methodsFor: 'private' stamp: 'gm 9/3/2003 16:22'!
addPointAtFrom
	"Adds the Point at the starting angle"
	vertices
		add: (self pointAtRadians: radiansFrom)! !

!PCSemiArc methodsFor: 'private' stamp: 'gm 9/3/2003 16:22'!
addPointAtTo
	"Adds the Point at the finishing angle"
	vertices
		add: (self pointAtRadians: radiansTo)! !

!PCSemiArc methodsFor: 'private' stamp: 'gm 9/3/2003 17:59'!
calculateVertices
	"Calculates the vertices for this SemiArc."
	(self fromAfterTo
			or: [self fromAndToInDifferentSide])
		ifTrue: [^ self].
	self addPointAtFrom; addIntermediatePoints; addPointAtTo; invertIfNeeded; removeInvalidPoints; translateToCenter! !

!PCSemiArc methodsFor: 'private' stamp: 'gm 9/3/2003 17:55'!
fromAfterTo
	"answers if From is after To, which makes this SemiArc useless"
	^ radiansFrom >= radiansTo
! !

!PCSemiArc methodsFor: 'private' stamp: 'gm 9/3/2003 17:57'!
fromAndToInDifferentSide
	"answers if From and To are in different side corresponding to Float pi (180 degrees)"
	^ radiansFrom < Float pi & (radiansTo > Float pi)! !

!PCSemiArc methodsFor: 'private' stamp: 'gm 3/3/2004 00:53'!
invertIfNeeded
	"inverts the arc vertices if the arc is on the lower half of the circle"
	| isUpSide |
	isUpSide := radiansFrom <= Float pi & (radiansTo <= Float pi).
	isUpSide 
		ifTrue: [vertices := vertices collect: [:each | each x @ each y negated]]! !

!PCSemiArc methodsFor: 'private' stamp: 'gm 3/3/2004 00:53'!
pointAtRadians: radiansNumber 
	"answers the arc's point at angle radiansNumber"
	| x y |
	x := (radius * radiansNumber cos) rounded.
	y := (radius * radiansNumber sin) rounded abs.
	^x @ y! !

!PCSemiArc methodsFor: 'private' stamp: 'gm 3/3/2004 00:54'!
pointAtX: xNumber 
	"answers the arc's point x@y when x is xNumber"
	| y |
	radius = 0 ifTrue: [^0 @ 0].
	y := (xNumber * (xNumber / radius) arcCos tan) rounded.
	^xNumber @ y! !

!PCSemiArc methodsFor: 'private' stamp: 'gm 3/3/2004 00:54'!
removeInvalidPoints
	"remove invalid points from the vertices collection"
	vertices removeAll: (vertices select: [:each | each x = 0 & (each y = 0)])! !

!PCSemiArc methodsFor: 'private' stamp: 'gm 3/3/2004 00:55'!
translateToCenter
	"translates vertices from relative positions around 0@0 to the real positions around the specified center"
	vertices := vertices 
				collect: [:each | each translateBy: center x @ center y]! !


!PCSemiArc class methodsFor: 'instance creation' stamp: 'gm 2/21/2003 23:24'!
radiansFrom: fromNumber radiansTo: toNumber center: aPoint radius: radiusNumber 
	^self new 
		initializeRadiansFrom: fromNumber
		radiansTo: toNumber
		center: aPoint
		radius: radiusNumber! !


!PCSemiArcTest methodsFor: 'Testing' stamp: 'gm 2/21/2003 23:30'!
testCreation1st
	| semiArc |
	semiArc _ PCSemiArc
				radiansFrom: 10 degreesToRadians
				radiansTo: 20 degreesToRadians
				center: 30 @ 30
				radius: 50.
	self assert: semiArc radiansFrom = 10 degreesToRadians.
	self assert: semiArc radiansTo = 20 degreesToRadians.
	self assert: semiArc center = (30 @ 30).
	self assert: semiArc radius = 50! !

!PCSemiArcTest methodsFor: 'Testing' stamp: 'gm 2/21/2003 23:31'!
testCreation1stTo2nd
	| semiArc |
	semiArc _ PCSemiArc
				radiansFrom: 10 degreesToRadians
				radiansTo: 170 degreesToRadians
				center: 30 @ 30
				radius: 50.
	self assert: semiArc radiansFrom = 10 degreesToRadians.
	self assert: semiArc radiansTo = 170 degreesToRadians.
	self assert: semiArc center = (30 @ 30).
	self assert: semiArc radius = 50! !

!PCSemiArcTest methodsFor: 'Testing' stamp: 'gm 2/21/2003 23:33'!
testCreation1stTo4th
	| semiArc |
	semiArc _ PCSemiArc
				radiansFrom: 10 degreesToRadians
				radiansTo: 340 degreesToRadians
				center: 30 @ 30
				radius: 50.
	self assert: semiArc radiansFrom = 10 degreesToRadians.
	self assert: semiArc radiansTo = 340 degreesToRadians.
	self assert: semiArc center = (30 @ 30).
	self assert: semiArc radius = 50! !

!PCSemiArcTest methodsFor: 'Testing' stamp: 'gm 2/21/2003 23:30'!
testCreation2nd
	| semiArc |
	semiArc _ PCSemiArc
				radiansFrom: 100 degreesToRadians
				radiansTo: 150 degreesToRadians
				center: 30 @ 30
				radius: 50.
	self assert: semiArc radiansFrom = 100 degreesToRadians.
	self assert: semiArc radiansTo = 150 degreesToRadians.
	self assert: semiArc center = (30 @ 30).
	self assert: semiArc radius = 50! !

!PCSemiArcTest methodsFor: 'Testing' stamp: 'gm 2/21/2003 23:32'!
testCreation2ndTo3rd
	| semiArc |
	semiArc _ PCSemiArc
				radiansFrom: 150 degreesToRadians
				radiansTo: 250 degreesToRadians
				center: 30 @ 30
				radius: 50.
	self assert: semiArc radiansFrom = 150 degreesToRadians.
	self assert: semiArc radiansTo = 250 degreesToRadians.
	self assert: semiArc center = (30 @ 30).
	self assert: semiArc radius = 50! !

!PCSemiArcTest methodsFor: 'Testing' stamp: 'gm 2/21/2003 23:31'!
testCreation3rd
	| semiArc |
	semiArc _ PCSemiArc
				radiansFrom: 200 degreesToRadians
				radiansTo: 250 degreesToRadians
				center: 30 @ 30
				radius: 50.
	self assert: semiArc radiansFrom = 200 degreesToRadians.
	self assert: semiArc radiansTo = 250 degreesToRadians.
	self assert: semiArc center = (30 @ 30).
	self assert: semiArc radius = 50! !

!PCSemiArcTest methodsFor: 'Testing' stamp: 'gm 2/21/2003 23:32'!
testCreation3rdTo4th
	| semiArc |
	semiArc _ PCSemiArc
				radiansFrom: 250 degreesToRadians
				radiansTo: 350 degreesToRadians
				center: 30 @ 30
				radius: 50.
	self assert: semiArc radiansFrom = 250 degreesToRadians.
	self assert: semiArc radiansTo = 350 degreesToRadians.
	self assert: semiArc center = (30 @ 30).
	self assert: semiArc radius = 50! !

!PCSemiArcTest methodsFor: 'Testing' stamp: 'gm 2/21/2003 23:31'!
testCreation4th
	| semiArc |
	semiArc _ PCSemiArc
				radiansFrom: 300 degreesToRadians
				radiansTo: 350 degreesToRadians
				center: 30 @ 30
				radius: 50.
	self assert: semiArc radiansFrom = 300 degreesToRadians.
	self assert: semiArc radiansTo = 350 degreesToRadians.
	self assert: semiArc center = (30 @ 30).
	self assert: semiArc radius = 50! !

!PCSemiArcTest methodsFor: 'Testing' stamp: 'gm 2/21/2003 23:33'!
testCreation4thTo1st
	| semiArc |
	semiArc _ PCSemiArc
				radiansFrom: 350 degreesToRadians
				radiansTo: 10 degreesToRadians
				center: 30 @ 30
				radius: 50.
	self assert: semiArc radiansFrom = 350 degreesToRadians.
	self assert: semiArc radiansTo = 10 degreesToRadians.
	self assert: semiArc center = (30 @ 30).
	self assert: semiArc radius = 50! !

PCPieChartMorph removeSelector: #balloonTextFor:!
